/*  Web Designer
   Copyright (C) 1999  LADISLAS Willhem

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

   Author's email : zillprog@freesurf.fr

   snailmail : 
   		LADISLAS Willhem
		2, rue du Serpolet
		95490 VAUREAL
		FRANCE
 */

#include "webdesigner.h"

/*
   This files contains all the functions concerning the "common" html tags :
   tag_insert_exec()
   choose_H()
   html_comment()

 */

void
insert_path_exec(GtkWidget * w, GtkFileSelection * fs)
{

  gchar *path;

 path = gtk_file_selection_get_filename (GTK_FILE_SELECTION (fs));

  if (path[strlen (path) - 1] == '/')
    {		/* checks if it a directory path instead of a file path */
      gtk_widget_destroy (filew);
      merror ("No file has been selected !");
      return;
    }

	gtk_text_set_point (GTK_TEXT (sheet[curfile].text), gtk_editable_get_position (GTK_EDITABLE (sheet[curfile].text)));

 gtk_text_insert (GTK_TEXT (sheet[curfile].text), fixed_font, NULL, NULL, path, -1);

} /* fin de insert_path_exec */

void 
dialog_insert_path (void)
{

  filew = gtk_file_selection_new ("Insert path...");

  /* Connect the ok_button to file_ok_sel function */
  gtk_signal_connect (GTK_OBJECT (GTK_FILE_SELECTION (filew)->ok_button),
		      "clicked", (GtkSignalFunc) insert_path_exec, filew);

  gtk_signal_connect_object (GTK_OBJECT (GTK_FILE_SELECTION (filew)->ok_button), "clicked", (GtkSignalFunc) gtk_widget_destroy, GTK_OBJECT (filew));

  /* Connect the cancel_button to destroy the widget */
  gtk_signal_connect_object (GTK_OBJECT (GTK_FILE_SELECTION (filew)->cancel_button), "clicked", (GtkSignalFunc) gtk_widget_destroy, GTK_OBJECT (filew));

  gtk_widget_show (filew);
}				/* fin de dialog_insert_path() */

void
tag_info_exec (int Opcode)
{
  gtk_text_freeze (GTK_TEXT (tag_window));
  gtk_text_set_point (GTK_TEXT (tag_window), 0);
  gtk_text_forward_delete (GTK_TEXT (tag_window), gtk_text_get_length (GTK_TEXT (tag_window)));

  switch (Opcode)
    {
    case 0:
      gtk_text_insert (GTK_TEXT (tag_window), fixed_font, NULL, NULL, "<FONT SIZE=[1..7] COLOR=[color] FACE=[font]> text </FONT>", -1);
      break;


    case 1:
      gtk_text_insert (GTK_TEXT (tag_window), fixed_font, NULL, NULL, "<B> text </B>", -1);
      break;

    case 2:
      gtk_text_insert (GTK_TEXT (tag_window), fixed_font, NULL, NULL, "<I> text </I>", -1);
      break;

    case 3:
      gtk_text_insert (GTK_TEXT (tag_window), fixed_font, NULL, NULL, "<U> text </U>", -1);
      break;

    case 8:
      gtk_text_insert (GTK_TEXT (tag_window), fixed_font, NULL, NULL, "<PRE> text </PRE>", -1);
      break;

    case 11:
      gtk_text_insert (GTK_TEXT (tag_window), fixed_font, NULL, NULL, "<P ALIGN = left|center|right|justify > text </P>", -1);
      break;

    case 12:
      gtk_text_insert (GTK_TEXT (tag_window), fixed_font, NULL, NULL, "<!-- text -->", -1);
      break;

    case 13:
      gtk_text_insert (GTK_TEXT (tag_window), fixed_font, NULL, NULL, "<BIG> text </BIG>", -1);
      break;

    case 14:
      gtk_text_insert (GTK_TEXT (tag_window), fixed_font, NULL, NULL, "<SMALL> text </SMALL>", -1);
      break;

    case 15:
      gtk_text_insert (GTK_TEXT (tag_window), fixed_font, NULL, NULL, "<BLINK> text </BLINK>", -1);
      break;

    case 16:
      gtk_text_insert (GTK_TEXT (tag_window), fixed_font, NULL, NULL, "<CITE> text </CITE>", -1);
      break;

    case 17:
      gtk_text_insert (GTK_TEXT (tag_window), fixed_font, NULL, NULL, "<HTML> text </HTML>", -1);
      break;

    case 18:
      gtk_text_insert (GTK_TEXT (tag_window), fixed_font, NULL, NULL, "<HEAD> text </HEAD>", -1);
      break;

    case 19:
      gtk_text_insert (GTK_TEXT (tag_window), fixed_font, NULL, NULL, "<BODY ALINK=[color] LINK=[color] VLINK=[color] BGCOLOR=[color] TEXT=[color] BACKGROUND=[file] ONLOAD=[script]> text </BODY>", -1);
      break;

    case 20:
      gtk_text_insert (GTK_TEXT (tag_window), fixed_font, NULL, NULL, "<TITLE> text </TITLE>", -1);
      break;

    case 21:
      gtk_text_insert (GTK_TEXT (tag_window), fixed_font, NULL, NULL, "<BANNER> text </BANNER>", -1);
      break;

    case 22:
      gtk_text_insert (GTK_TEXT (tag_window), fixed_font, NULL, NULL, "<EM> text </EM>", -1);
      break;

    case 23:
      gtk_text_insert (GTK_TEXT (tag_window), fixed_font, NULL, NULL, "<STRIKE> text </STRIKE>", -1);
      break;

    case 24:
      gtk_text_insert (GTK_TEXT (tag_window), fixed_font, NULL, NULL, "<SUP> text </SUP>", -1);
      break;

    case 25:
      gtk_text_insert (GTK_TEXT (tag_window), fixed_font, NULL, NULL, "<SUB> text </SUB>", -1);
      break;

    case 26:
      gtk_text_insert (GTK_TEXT (tag_window), fixed_font, NULL, NULL, "<TT> text </TT>", -1);
      break;

    case 27:
      gtk_text_insert (GTK_TEXT (tag_window), fixed_font, NULL, NULL, "<KBD> text </KBD>", -1);
      break;


    }

  gtk_text_thaw (GTK_TEXT (tag_window));

}				/* fin de tag_info_exec */

void
tag_insert_exec (GtkWidget * widget, int Opcode)
{
  int i, j, x = 0;
  char *text = malloc (150);
  gboolean insert = FALSE;

  switch (Opcode)
    {
    case 0:
      text = (char *) "<FONT></FONT>";
      tag_info_exec (0);
      break;

    case 1:
      text = (char *) "<B></B>";
      tag_info_exec (1);
      break;

    case 2:
      text = (char *) "<I></I>";
      tag_info_exec (2);
      break;

    case 3:
      text = (char *) "<U></U>";
      tag_info_exec (3);
      break;

    case 4:
      text = (char *) "<P ALIGN=\"left\"></P>";
      tag_info_exec (11);
      break;

    case 5:
      text = (char *) "<P ALIGN=\"center\"></P>";
      tag_info_exec (11);
      break;

    case 6:
      text = (char *) "<P ALIGN=\"right\"></P>";
      tag_info_exec (11);
      break;

    case 7:
      text = (char *) "<P ALIGN=\"justify\"></P>";
      tag_info_exec (11);
      break;

    case 8:
      text = (char *) "<PRE></PRE>";
      tag_info_exec (8);
      break;

    case 9:
      text = (char *) "<BLOCKQUOTE></BLOCKQUOTE>";
      break;

    case 10:
      text = (char *) "<BR>\n";
      break;

    case 11:
      text = (char *) "<CENTER></CENTER>";
      tag_info_exec (11);
      break;

    case 12:
      tag_info_exec (12);
      html_comment ();
      lasttag_nb = Opcode;
      return;
      break;

    case 13:
      text = (char *) "<BIG></BIG>";
      tag_info_exec (13);
      break;

    case 14:
      text = (char *) "<SMALL></SMALL>";
      tag_info_exec (14);
      break;

    case 15:
      text = (char *) "<BLINK></BLINK>";
      tag_info_exec (15);
      break;

    case 16:
      text = (char *) "<CITE></CITE>";
      tag_info_exec (16);
      break;

    case 17:
      text = (char *) "<HTML></HTML>";
      tag_info_exec (17);
      break;

    case 18:
      text = (char *) "<HEAD></HEAD>";
      tag_info_exec (18);
      break;

    case 19:
      text = (char *) "<BODY></BODY>";
      tag_info_exec (19);
      break;

    case 20:
      text = (char *) "<TITLE></TITLE>";
      tag_info_exec (20);
      break;

    case 21:
      text = (char *) "<BANNER></BANNER>";
      tag_info_exec (21);
      break;

    case 22:
      text = (char *) "<EM></EM>";
      tag_info_exec (22);
      break;

    case 23:
      text = (char *) "<STRIKE></STRIKE>";
      tag_info_exec (23);
      break;

    case 24:
      text = (char *) "<SUP></SUP>";
      tag_info_exec (24);
      break;

    case 25:
      text = (char *) "<SUB></SUB>";
      tag_info_exec (25);
      break;

    case 26:
      text = (char *) "<TT></TT>";
      tag_info_exec (26);
      break;

    case 27:
      text = (char *) "<KBD></KBD>";
      tag_info_exec (27);
      break;

    case 28:
      text = (char *) "<LISTING></LISTING>";
      break;

    case 29:
      text = (char *) "<CODE></CODE>";
      break;

    case 30:
      text = (char *) "<INPUT TYPE=\"password\" NAME=\"\" VALUE=\"\">";
      break;

    case 31:
      text = (char *) "<INPUT TYPE=\"text\" NAME=\"\" VALUE=\"\">";
      break;

    case 32:
      text = (char *) "<INPUT TYPE=\"reset\" VALUE=\"\">";
      break;

    case 33:
      text = (char *) "<INPUT TYPE=\"submit\" VALUE=\"\">";
      break;

    case 34:
      text = (char *) "<HR COLOR=\"\" WIDTH=\"\">";
      break;

    case 35:
      text = (char *) "<INPUT TYPE=\"checkbox\" NAME=\"\" VALUE=\"\">";
      break;

    case 36:
      text = (char *) "<INPUT TYPE=\"radio\" NAME=\"\" VALUE=\"\">";
      break;

    case 37:
      text = (char *) "<INPUT TYPE=\"radio\" NAME=\"\" VALUE=\"\">";
      break;

    case 38:
      text = (char *) "<OL TYPE=\"\" START=\"\"></OL>";
      break;

    case 39:
      text = (char *) "<UL TYPE=\"\"></UL>";
      break;

    case 40:
      text = (char *) "<LI>";
      break;

    case 41:
      text = (char *) "<DD>";
      break;

    case 42:
      text = (char *) "<DT>";
      break;

    case 43:
      text = (char *) "<DL></DL>";
      break;

    case 44:
      text = (char *) "<TEXTAREA COLS=\"\" NAME=\"\" ROWS=\"\" WRAP=\"\"></TEXTAREA>";
      break;

    case 45:
      text = (char *) "<FORM ACTION=\"\" METHOD=\"\" NAME=\"\"></FORM>";
      break;

    case 46:
      text = (char *) "<INPUT TYPE=\"hidden\" NAME=\"\" VALUE=\"\">";
      break;

    case 47:
      text = (char *) "<A HREF=\"\"></A>";
      break;

    case 48:
      text = (char *) "<BUTTON NAME=\"\" TYPE=\"\"></BUTTON>";
      break;

    case 49:
      text = (char *) "<H1></H1>";
      break;

    case 50:
      text = (char *) "<H2></H2>";
      break;

    case 51:
      text = (char *) "<H3></H3>";
      break;

    case 52:
      text = (char *) "<H4></H4>";
      break;

    case 53:
      text = (char *) "<H5></H5>";
      break;

    case 54:
      text = (char *) "<H6></H6>";
      break;

    case 55:
      text = (char *) "<IMG SRC=\"\" LOWSRC=\"\" ALT=\"\">";
      break;

    case 56:
      text = (char *) "<A NAME=\"\" ></A>";
      break;

    case 57:
      text = (char *) "<A HREF=\"#\"></A>";
      break;

    case 58:
      text = (char *) "<A HREF=#top></A>";
      break;

    case 59:
      text = (char *) "<DIR></DIR>";
      break;

    case 60:
      text = (char *) "<MENU></MENU>";
      break;

    case 61:
      text = (char *) "<TABLE></TABLE>";
      break;

    case 62:
      text = (char *) "<TH></TH>";
      break;

    case 63:
      text = (char *) "<TR></TR>";
      break;

    case 64:
      text = (char *) "<TD></TD>";
      break;

    case 65:
      text = (char *) "<CAPTION></CAPTION>";
      break;

    case 66:
      text = (char *) "<FIELDSET></FIELDSET>";
      break;

    case 67:
      text = (char *) "<APPLET CODE=\"\" HEIGHT=\"\" WIDTH=\"\"></APPLET>";
      break;

    case 68:
      text = (char *) "<SCRIPT language=\"\"></SCRIPT>";
      break;

    case 69:
      text = (char *) "<PARAM NAME= VALUE=>";
      break;

    case 70:
      text = (char *) "<FONT SIZE=\"+1\"></FONT>";
      break;

    case 71:
      text = (char *) "<FONT SIZE=\"-1\"></FONT>";
      break;

    case 72:
      text = (char *) "<BASEFONT SIZE="" COLOR="" FACE=""></FONT>";
      break;

    case 73:
      text = (char *) "<STYLE TYPE=\"text/css\"></STYLE>";
      break;

    case 74:
      text = (char *) "<BASE HREF=\"\">";
      break;

/* For Cascading style sheets */
    case 75:
      text = (char *) "<STYLE TYPE=\"text/css\"></STYLE>";
      break;

    case 76:
      text = (char *) "<DIV ID=\"\" CLASS=\"\"></STYLE>";
      break;

    case 77:
      text = (char *) "<SPAN ID=\"\" CLASS=\"\"></STYLE>";
      break;

    case 78:
      text = (char *) "<DIV ID=\"\" CLASS=\"\"></STYLE>";
      break;

    case 79:
      text = (char *) "<FRAMESET COLS=\"\" ROWS=\"\"></FRAMESET>";
      break;

    case 80:
      text = (char *) "<FRAME>";
      break;

    case 81:
      text = (char *) "<NOFRAMES></NOFRAMES>";
      break;

    case 82:
      text = (char *) "<IFRAME></IFRAME>";
      break;

    }

  lasttag_nb = Opcode;

  if (numfileopened == 0)
    return;

  j = strlen (text);
  for (i = 0; i < strlen (text); i++)
    {
      if (text[j - i] == '<')
	x = i;
    }

/* for an "intelligent" behavior  -> when text is highlighted the tags are putted on its left and right */
if (GTK_EDITABLE(sheet[curfile].text)->has_selection == 1) {
	 gtk_editable_cut_clipboard (GTK_EDITABLE (sheet[curfile].text));
	 insert = TRUE;
	}

    gtk_text_set_point (GTK_TEXT (sheet[curfile].text), gtk_editable_get_position (GTK_EDITABLE (sheet[curfile].text)));

  gtk_text_insert (GTK_TEXT (sheet[curfile].text), fixed_font, &blue, NULL, text, strlen (text));

  i = gtk_text_get_point (GTK_TEXT (sheet[curfile].text));

  gtk_editable_set_position (GTK_EDITABLE (sheet[curfile].text), i - x);

  if (insert) {
	 gtk_editable_paste_clipboard (GTK_EDITABLE (sheet[curfile].text));
	}

  if (sheet[curfile].saved == TRUE)
    sheet[curfile].saved = FALSE;
}				/* fin de tag_insert_exec() */

void
repeat_tag (void)
{
  if (lasttag_nb == -1)
    {
      return;
    }

  tag_insert_exec (NULL, lasttag_nb);
}				/* fin de repeat_tag */

void
choose_H (void)
{
  GtkWidget *chooH_window;
  GtkWidget *chooH_frame;
  GtkWidget *chooH_vbox;
  GtkWidget *chooH_button;

  if (numfileopened == 0)
    return;

  chooH_window = gtk_window_new (GTK_WINDOW_DIALOG);
  gtk_window_set_title (GTK_WINDOW (chooH_window), "Heading");

  chooH_frame = gtk_frame_new (" Heading ");
  gtk_container_border_width (GTK_CONTAINER (chooH_frame), 5);

  chooH_vbox = gtk_vbox_new (FALSE, 1);
  gtk_container_border_width (GTK_CONTAINER (chooH_vbox), 2);
  gtk_container_add (GTK_CONTAINER (chooH_window), chooH_frame);
  gtk_container_add (GTK_CONTAINER (chooH_frame), chooH_vbox);
  gtk_widget_show (chooH_vbox);
  gtk_widget_show (chooH_frame);

  chooH_button = gtk_button_new_with_label ("Heading 1");
  gtk_box_pack_start (GTK_BOX (chooH_vbox), chooH_button, TRUE, TRUE, 0);
  gtk_widget_show (chooH_button);

  gtk_signal_connect (GTK_OBJECT (chooH_button), "clicked", GTK_SIGNAL_FUNC (tag_insert_exec), (int *) 49);

  gtk_signal_connect_object_after (GTK_OBJECT (chooH_button), "clicked", GTK_SIGNAL_FUNC (gtk_widget_destroy), GTK_OBJECT (chooH_window));

  chooH_button = gtk_button_new_with_label ("Heading 2");
  gtk_box_pack_start (GTK_BOX (chooH_vbox), chooH_button, TRUE, TRUE, 0);
  gtk_widget_show (chooH_button);

  gtk_signal_connect (GTK_OBJECT (chooH_button), "clicked", GTK_SIGNAL_FUNC (tag_insert_exec), (int *) 50);
  gtk_signal_connect_object_after (GTK_OBJECT (chooH_button), "clicked", GTK_SIGNAL_FUNC (gtk_widget_destroy), GTK_OBJECT (chooH_window));

  chooH_button = gtk_button_new_with_label ("Heading 3");
  gtk_box_pack_start (GTK_BOX (chooH_vbox), chooH_button, TRUE, TRUE, 0);
  gtk_widget_show (chooH_button);

  gtk_signal_connect (GTK_OBJECT (chooH_button), "clicked", GTK_SIGNAL_FUNC (tag_insert_exec), (int *) 51);

  gtk_signal_connect_object_after (GTK_OBJECT (chooH_button), "clicked", GTK_SIGNAL_FUNC (gtk_widget_destroy), GTK_OBJECT (chooH_window));

  chooH_button = gtk_button_new_with_label ("Heading 4");
  gtk_box_pack_start (GTK_BOX (chooH_vbox), chooH_button, TRUE, TRUE, 0);
  gtk_widget_show (chooH_button);

  gtk_signal_connect (GTK_OBJECT (chooH_button), "clicked", GTK_SIGNAL_FUNC (tag_insert_exec), (int *) 52);

  gtk_signal_connect_object_after (GTK_OBJECT (chooH_button), "clicked", GTK_SIGNAL_FUNC (gtk_widget_destroy), GTK_OBJECT (chooH_window));

  chooH_button = gtk_button_new_with_label ("Heading 5");
  gtk_box_pack_start (GTK_BOX (chooH_vbox), chooH_button, TRUE, TRUE, 0);
  gtk_widget_show (chooH_button);

  gtk_signal_connect (GTK_OBJECT (chooH_button), "clicked", GTK_SIGNAL_FUNC (tag_insert_exec), (int *) 53);

  gtk_signal_connect_object_after (GTK_OBJECT (chooH_button), "clicked", GTK_SIGNAL_FUNC (gtk_widget_destroy), GTK_OBJECT (chooH_window));

  chooH_button = gtk_button_new_with_label ("Heading 6");
  gtk_box_pack_start (GTK_BOX (chooH_vbox), chooH_button, TRUE, TRUE, 0);
  gtk_widget_show (chooH_button);

  gtk_signal_connect (GTK_OBJECT (chooH_button), "clicked", GTK_SIGNAL_FUNC (tag_insert_exec), (int *) 54);

  gtk_signal_connect_object_after (GTK_OBJECT (chooH_button), "clicked", GTK_SIGNAL_FUNC (gtk_widget_destroy), GTK_OBJECT (chooH_window));

  gtk_widget_show (chooH_window);
}				/* fin de choose_H */



void
html_comment (void)
{
  int i;
  gboolean insert = FALSE;

  if (numfileopened == 0)
    return;

/* for an "intelligent" behavior  -> when text is highlighted the tags are putted on its left and right */
if (GTK_EDITABLE(sheet[curfile].text)->has_selection == 1) {
gtk_editable_cut_clipboard (GTK_EDITABLE (sheet[curfile].text));
insert = TRUE;
}
  gtk_text_set_point (GTK_TEXT (sheet[curfile].text), gtk_editable_get_position (GTK_EDITABLE (sheet[curfile].text)));

  gtk_text_insert (GTK_TEXT (sheet[curfile].text), fixed_font, &red, NULL, "<!--  -->", 9);
  i = gtk_text_get_point (GTK_TEXT (sheet[curfile].text));

  gtk_editable_set_position (GTK_EDITABLE (sheet[curfile].text), i - 4);

if (insert) {
gtk_editable_paste_clipboard (GTK_EDITABLE (sheet[curfile].text));
}

  if (sheet[curfile].saved == TRUE)
    sheet[curfile].saved = FALSE;
}				/* fin de html_comment() */


/*
   void html_font(void) {
   int i;

   if (numfileopened == 0) return;

   gtk_text_freeze(GTK_TEXT(sheet[curfile].text));
   gtk_text_set_point(GTK_TEXT(sheet[curfile].text), gtk_editable_get_position(GTK_EDITABLE(sheet[curfile].text)));

   gtk_text_insert(GTK_TEXT(sheet[curfile].text),fixed_font,NULL,NULL,"<FONT></FONT>",13);
   i = gtk_text_get_point(GTK_TEXT(sheet[curfile].text));

   gtk_editable_set_position(GTK_EDITABLE(sheet[curfile].text), i-7);

   gtk_text_thaw(GTK_TEXT(sheet[curfile].text));
   if (sheet[curfile].saved == TRUE) sheet[curfile].saved = FALSE;
   }  fin de html_font() */
