/*  Web Designer
   Copyright (C) 1999  LADISLAS Willhem

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

   Author's email : zillprog@freesurf.fr

   snailmail : 
   LADISLAS Willhem
   2, rue du Serpolet
   95490 VAUREAL
   FRANCE
 */

/* functions contained in this file :

   refresh_clist(void)
   gtk_swpg(void)
   void coord(GtkWidget *widget, gpointer data)
   void clist_selection_made(GtkWidget *clist, gint row, gint column, GdkEventButton *event, gpointer data)

 */




#include "webdesigner.h"

void
refresh_clist (void)
{

  FILE *infile;
  char bufferp[255];
  gchar *titles[5] =
  {"File name", "Path", "Access", "Size", "Date"};
  int i;
  long length, prj_length;
  char number[5];
  char number2[25];

  gtk_clist_freeze (GTK_CLIST (clist));
  gtk_clist_clear (GTK_CLIST (clist));

  prj_length = 0;
  for (i = 1; i < numprjfiles + 1; i++)
    {
      
sprintf (number, "%d", i);
      titles[0] = getname (projectfiles[i].path);
      infile = fopen (projectfiles[i].path, "rb");
      fseek (infile, 0L, SEEK_END);

      length = ftell (infile);
      fclose (infile);
      prj_length = prj_length + length;
      sprintf (number2, "%lu", length);
      titles[3] = number2;
      titles[1] = projectfiles[i].path;

      if ((access (projectfiles[i].path, W_OK)) == 0)
	titles[2] = "read / write";
      else
	titles[2] = "read only";

      gtk_clist_append (GTK_CLIST (clist), titles);
/*
   if (sheet[i].saved == TRUE) {
   pixm = gdk_pixmap_create_from_xpm(window->window, &mask, &color,"pixmaps/inprjico.xpm");
   gtk_clist_set_pixmap(GTK_CLIST(clist),i,4,pixm,mask);
   }
   else {
   pixm = gdk_pixmap_create_from_xpm(window->window, &mask, &color,"pixmaps/outprjico.xpm");
   gtk_clist_set_pixmap(GTK_CLIST(clist),i,4,pixm,mask);
   }
 */
    }

  gtk_clist_thaw (GTK_CLIST (clist));

  sprintf (bufferp, "Project : %s,   %d fichier(s),   %lu bytes", projectname, numprjfiles, prj_length);
  gtk_label_set (GTK_LABEL (clist_lbl), bufferp);

}				/* fin de refresh_clist() */





void
coord (GtkWidget * widget, gpointer data)
{
  char bufferp[60];

  sprintf (bufferp, " Line : %d, Column : %d", (GTK_TEXT (widget)->cursor_virtual_x) / 13, (GTK_TEXT (widget)->cursor_pos_x) / 7);

  gtk_statusbar_push (GTK_STATUSBAR (coord_status_bar), context_id, bufferp);

}				/* finf de coord() */



void
gtk_swpg (void)
{
  char bufferp[255];

  curfile = gtk_notebook_get_current_page (GTK_NOTEBOOK (notebook));
  sprintf (bufferp, "Web Designer - %s", sheet[curfile].chemin);
  gtk_window_set_title (GTK_WINDOW (window), bufferp);

  chdir (getpath (sheet[curfile].chemin));

  if (sheet[curfile].saved == TRUE)
    gtk_statusbar_push (GTK_STATUSBAR (file_status_bar), context_id, " State : file saved ");

  if (sheet[curfile].saved == FALSE)
    gtk_statusbar_push (GTK_STATUSBAR (file_status_bar), context_id, " State : file unsaved ");

#ifdef debugging
  sprintf (bufferp, "Current project : %s", projectname);
  gtk_statusbar_push (GTK_STATUSBAR (status_bar), context_id, bufferp);

  printf ("page : %d\nnbfileopened : %d\n", curfile, numfileopened);
  printf ("numprjfiles : %d\n\n", numprjfiles);

#endif

}				/* fin de gtk_swpg(); */


void
clist_selection_made (GtkWidget * clist, gint row, gint column, GdkEventButton * event, gpointer data)
{

  clist_row2 = row + 1;

}				/* fin de clist_selection_made() */



void
destroy_window (GtkWidget * widget, gpointer data)
{
  gtk_widget_destroy (data);
}				/* destroy_window() */



void
init_clist (void)
{
  gchar *titles[5] =
  {"File name", "Path", "Access", "Size", "Date"};
  int i;
  long length, prj_length;
  char number[5];
  char number2[25];
  char bufferp[255];
  FILE *infile;

  GtkWidget *clist_hbox;
  GtkWidget *scrolled_win;
  GtkWidget *clist_tb;

  clistdialog = gtk_window_new (GTK_WINDOW_DIALOG);
  gtk_widget_set_usize (GTK_WIDGET (clistdialog), 600, 220);
  gtk_window_set_title (GTK_WINDOW (clistdialog), "Project manager");

  clistvbox = gtk_vbox_new (FALSE, 1);
  gtk_container_add (GTK_CONTAINER (clistdialog), clistvbox);

  clist = gtk_clist_new_with_titles (5, titles);

  gtk_container_border_width (GTK_CONTAINER (clistvbox), 2);
  gtk_widget_show (clistvbox);

  clist_tb = gtk_toolbar_new (GTK_ORIENTATION_HORIZONTAL, GTK_TOOLBAR_BOTH);
  gtk_toolbar_set_button_relief (GTK_TOOLBAR (clist_tb), GTK_RELIEF_NONE);

  gtk_box_pack_start (GTK_BOX (clistvbox), clist_tb, FALSE, FALSE, 2);

  gtk_widget_show (clist_tb);

  gtk_toolbar_set_space_size (GTK_TOOLBAR (clist_tb), 10);
  gtk_toolbar_append_space (GTK_TOOLBAR (clist_tb));

  gtk_toolbar_append_item (GTK_TOOLBAR (clist_tb), NULL, "New project",
			   "", new_pixmap (15, window->window, &color),
			   GTK_SIGNAL_FUNC (new_project), NULL);

  gtk_toolbar_append_item (GTK_TOOLBAR (clist_tb), NULL, "Open projet",
			   "", new_pixmap (17, window->window, &color),
			   GTK_SIGNAL_FUNC (open_project_dialog), NULL);

  gtk_toolbar_append_item (GTK_TOOLBAR (clist_tb), NULL, "Save project",
			   "", new_pixmap (18, window->window, &color),
			   GTK_SIGNAL_FUNC (save_project), NULL);

  gtk_toolbar_append_item (GTK_TOOLBAR (clist_tb), NULL, "Close project",
			   "", new_pixmap (16, window->window, &color),
			   GTK_SIGNAL_FUNC (close_project), NULL);

  gtk_toolbar_append_space (GTK_TOOLBAR (clist_tb));


  gtk_toolbar_append_item (GTK_TOOLBAR (clist_tb), NULL, "Add file",
			   "", new_pixmap (36, window->window, &color),
			   GTK_SIGNAL_FUNC (add_afile_prj_dialog), NULL);

  gtk_toolbar_append_item (GTK_TOOLBAR (clist_tb), NULL, "Remove file",
			   "", new_pixmap (37, window->window, &color),
			   GTK_SIGNAL_FUNC (remove_file2), NULL);

  gtk_toolbar_append_item (GTK_TOOLBAR (clist_tb), NULL, "Open all files",
			   "", new_pixmap (38, window->window, &color),
			   GTK_SIGNAL_FUNC (open_all_prjfiles), NULL);

  gtk_toolbar_append_item (GTK_TOOLBAR (clist_tb), NULL, "Close all files",
			   "", new_pixmap (39, window->window, &color),
			   GTK_SIGNAL_FUNC (close_all_prjfiles), NULL);

  gtk_toolbar_append_item (GTK_TOOLBAR (clist_tb), NULL, "Close project manager",
			   "", new_pixmap (1, window->window, &color),
		GTK_SIGNAL_FUNC (destroy_window), GTK_OBJECT (clistdialog));

  /* A generic scrolled window */
  scrolled_win = gtk_scrolled_window_new (NULL, NULL);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolled_win),
				  GTK_POLICY_AUTOMATIC,
				  GTK_POLICY_AUTOMATIC);
  gtk_box_pack_start (GTK_BOX (clistvbox), scrolled_win,
		      TRUE, TRUE, 5);
  gtk_widget_show (scrolled_win);

  /* It isn't necessary to shadow the border, but it looks nice :) */
  gtk_clist_set_shadow_type (GTK_CLIST (clist), GTK_SHADOW_OUT);

  /* What however is important, is that we set the column widths as
     * they will never be right otherwise. Note that the columns are
     * numbered from 0 and up (to 1 in this case).
   */
  gtk_clist_set_column_width (GTK_CLIST (clist), 0, 70);
  gtk_clist_set_column_width (GTK_CLIST (clist), 1, 220);
  gtk_clist_set_column_width (GTK_CLIST (clist), 2, 105);
  gtk_clist_set_column_width (GTK_CLIST (clist), 3, 80);
  gtk_clist_set_column_width (GTK_CLIST (clist), 4, 30);

  prj_length = 0;

  /* loads files data into the clist */
  for (i = 1; i < numprjfiles + 1; i++)
    {
      
sprintf (number, "%d", i);
      titles[0] = getname (projectfiles[i].path);
      infile = fopen (projectfiles[i].path, "rb");
      fseek (infile, 0L, SEEK_END);

      length = ftell (infile);
      fclose (infile);
      prj_length = prj_length + length;
      sprintf (number2, "%lu", length);
      titles[3] = number2;
      titles[1] = projectfiles[i].path;

      if ((access (projectfiles[i].path, W_OK)) == 0)
	titles[2] = "read / write";
      else
	titles[2] = "read only";

      gtk_clist_append (GTK_CLIST (clist), titles);
/*
   if (sheet[i].saved == TRUE) {
   pixm = gdk_pixmap_create_from_xpm(window->window, &mask, &color,"pixmaps/inprjico.xpm");
   gtk_clist_set_pixmap(GTK_CLIST(clist),i,4,pixm,mask);
   }
   else {
   pixm = gdk_pixmap_create_from_xpm(window->window, &mask, &color,"pixmaps/outprjico.xpm");
   gtk_clist_set_pixmap(GTK_CLIST(clist),i,4,pixm,mask);
   }
 */
    }

  gtk_scrolled_window_add_with_viewport (GTK_SCROLLED_WINDOW (scrolled_win), clist);

  gtk_widget_show (clist);
  gtk_widget_show (clistdialog);

  sprintf (bufferp, "Projet : %s,   %d fichier(s),   %lu bytes", projectname, numprjfiles, prj_length);

  clist_hbox = gtk_hbox_new (FALSE, 1);

  clist_lbl = gtk_label_new (bufferp);
  gtk_box_pack_start (GTK_BOX (clist_hbox), clist_lbl, FALSE, FALSE, 0);
  gtk_widget_show (clist_lbl);

  gtk_box_pack_start (GTK_BOX (clistvbox), clist_hbox, FALSE, FALSE, 0);
  gtk_widget_show (clist_hbox);

  gtk_signal_connect_object (GTK_OBJECT (clist), "event", GTK_SIGNAL_FUNC (button_press), GTK_OBJECT (popmenu2));

  gtk_signal_connect (GTK_OBJECT (clist), "select_row", GTK_SIGNAL_FUNC (clist_selection_made), NULL);

}				/* fin de init_clist */
