/*  Web Designer
   Copyright (C) 1999  LADISLAS Willhem

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

   Author's email : zillprog@freesurf.fr

   snailmail : LADISLAS Willhem
   2, rue du Serpolet
   95490 VAUREAL
   FRANCE
 */

#include "webdesigner.h"

void remove_tags(void)
{
  char *buff;
  int i, j;
  gboolean REMOVE=FALSE;

  if (numfileopened == 0)
    return;

  i = gtk_text_get_length (GTK_TEXT (sheet[curfile].text));

  if (i == 0)
    return;

  buff = gtk_editable_get_chars (GTK_EDITABLE (sheet[curfile].text), 0, i);

  newfile ();
  
    gtk_text_freeze (GTK_TEXT (sheet[curfile].text));

 for (j = 0; j < i; j++)
    {
	if (buff[j] == '<')
		REMOVE=TRUE; 

	if (buff[j] == '>') {
		REMOVE=FALSE;
		goto end;
	}

	if (REMOVE == TRUE) {
		goto end;
	}
	else {
	        gtk_text_insert (GTK_TEXT (sheet[curfile].text), fixed_font, NULL, NULL, &buff[j], 1);
	}

    end:
    }



    gtk_text_thaw (GTK_TEXT (sheet[curfile].text));

} /* fin de remove_tags */


void
inst_txt (GtkEditable * editable, const char *text, int len, int *pos, gpointer data)
{
  int i;
  const char *buffer = text;

  len = strlen (buffer);
  if (len > 1)
    return;

/* test de numro */
  i = 0;
  if ((isdigit (buffer[i])) != 0 && intag == TRUE)
    {
      gtk_text_backward_delete (GTK_TEXT (sheet[curfile].text), 1);
      gtk_text_insert (GTK_TEXT (sheet[curfile].text), fixed_font, &red, NULL, &buffer[i], 1);
      return;
    }

/*  if ((isalpha (buffer[i])) != 0) return; */

  if (buffer[i] == '\n')
    return;

  if (buffer[i] == '\b')
    return;

  if (buffer[i] == '<')
    {
      colour = blue;
      intag = TRUE;
    }

  if (buffer[i] == '>')
    {
      gtk_text_backward_delete (GTK_TEXT (sheet[curfile].text), 1);
      gtk_text_insert (GTK_TEXT (sheet[curfile].text), fixed_font, &colour, NULL, &buffer[i], 1);
      colour = black;
      intag = FALSE;
      return;
    }

  if (buffer[i] == '"')
    {

      if (instring == TRUE)
	{
	  gtk_text_backward_delete (GTK_TEXT (sheet[curfile].text), 1);
	  gtk_text_insert (GTK_TEXT (sheet[curfile].text), fixed_font, &colour, NULL, &buffer[i], 1);
	  colour = savecol;
	  instring = FALSE;
	  return;
	}

      if (instring == FALSE)
	{
	  savecol = colour;
	  colour = green;
	  instring = TRUE;
	}
    }
  gtk_text_backward_delete (GTK_TEXT (sheet[curfile].text), 1);
  gtk_text_insert (GTK_TEXT (sheet[curfile].text), fixed_font, &colour,
		   NULL, &buffer[i], 1);
}				/* fin de inst_txt() */

void
clipboard_actions (GtkWidget * w, guint Op)
{
  int i;

  if (numfileopened == 0)
    return;

/* 0: cut, 1: copy, 2: paste, 3: select all, 4: erase all, 5: paste in new doc */
  switch (Op)
    {
    case 0:
      gtk_editable_cut_clipboard (GTK_EDITABLE (sheet[curfile].text));
      gtk_statusbar_push (GTK_STATUSBAR (status_bar), context_id, " Selection cutted");
      break;

    case 1:
      gtk_editable_copy_clipboard (GTK_EDITABLE (sheet[curfile].text));
      gtk_statusbar_push (GTK_STATUSBAR (status_bar), context_id, " Selection copied ");
      break;

    case 2:
      gtk_editable_paste_clipboard (GTK_EDITABLE (sheet[curfile].text));
      gtk_statusbar_push (GTK_STATUSBAR (status_bar), context_id, " Text inserted ");
      break;

    case 3:
      i = gtk_text_get_length (GTK_TEXT (sheet[curfile].text));
      gtk_editable_select_region (GTK_EDITABLE (sheet[curfile].text), 0, i);
      gtk_statusbar_push (GTK_STATUSBAR (status_bar), context_id, " All text selected ");
      break;

    case 4:
      gtk_editable_delete_selection (GTK_EDITABLE (sheet[curfile].text));
      gtk_statusbar_push (GTK_STATUSBAR (status_bar), context_id, " Selection erased ");
      break;

    case 5:
      gtk_editable_copy_clipboard (GTK_EDITABLE (sheet[curfile].text));
      newfile ();
      gtk_editable_paste_clipboard (GTK_EDITABLE (sheet[curfile].text));
      gtk_statusbar_push (GTK_STATUSBAR (status_bar), context_id, " Text copied in new file ");
      break;
    }
}				/* fin de clipboard_actions */

void
go_line_exec (GtkWidget * wgt, gpointer data)
{

  char *buf, *haystack, *needle;
  int numlines, linenum;
  int a, b, len;
  float newadj;
  char bufferp[255];

  if (numfileopened == 0)
    return;

  gtk_text_freeze (GTK_TEXT (sheet[curfile].text));

  linenum = atoi (gtk_entry_get_text (GTK_ENTRY (wgt)));

  if (linenum < 1)
    {
      merror ("Invalid line number !");
      return;
    }

  numlines = 1;

  len = gtk_text_get_length (GTK_TEXT (sheet[curfile].text));

  if (len == 0)
    {
      merror ("File is empty !");
      return;
    }

  buf = gtk_editable_get_chars (GTK_EDITABLE (sheet[curfile].text), 1, len);

  a = 1;
  b = len;
  haystack = buf;
  do
    {
      needle = strchr (haystack, '\n');
      if (needle)
	{
	  haystack = needle + 1;
	  if (linenum == numlines)
	    b = needle - buf + 1;
	  numlines++;
	  if (linenum == numlines)
	    a = needle - buf + 1;
	}
    }
  while (needle != NULL);

  g_free (buf);

  if (linenum > numlines)
    {
      sprintf (bufferp, "File has only %d line(s) !", numlines);
      merror (bufferp);
      return;
    }


/*scrollbar_update(GTK_TEXT(sheet[curfile].text),numlines,linenum); */

  newadj = (linenum * GTK_ADJUSTMENT (GTK_TEXT (sheet[curfile].text)->vadj)->upper) / numlines - GTK_ADJUSTMENT (GTK_TEXT (sheet[curfile].text)->vadj)->page_increment;

  gtk_adjustment_set_value (GTK_ADJUSTMENT (GTK_TEXT (sheet[curfile].text)->vadj), newadj);

  gtk_text_set_point (GTK_TEXT (sheet[curfile].text), a + 1);
  gtk_editable_set_position (GTK_EDITABLE (sheet[curfile].text), a + 1);
  gtk_editable_select_region (GTK_EDITABLE (sheet[curfile].text), a, b);
  gtk_text_thaw (GTK_TEXT (sheet[curfile].text));

}				/* fin de go_line_exec() */


void
go_line (void)
{

  GtkWidget *hbutton;
  GtkWidget *lbl;
  GtkWidget *lwind;
  GtkWidget *lboxer;
  GtkWidget *hboxer;
  GtkWidget *frame;
  GtkWidget *entry;

  lwind = gtk_window_new (GTK_WINDOW_DIALOG);
  gtk_window_set_title (GTK_WINDOW (lwind), "Go to line #...");

  frame = gtk_frame_new ("");
  gtk_container_set_border_width (GTK_CONTAINER (frame), 5);
  lboxer = gtk_vbox_new (FALSE, 1);
  gtk_container_border_width (GTK_CONTAINER (lboxer), 2);
  gtk_container_add (GTK_CONTAINER (lwind), frame);
  gtk_container_add (GTK_CONTAINER (frame), lboxer);
  gtk_widget_show (lboxer);
  gtk_widget_show (frame);

  hboxer = gtk_hbox_new (FALSE, 1);
  lbl = gtk_label_new (" Line # : ");
  gtk_box_pack_start (GTK_BOX (hboxer), lbl, FALSE, FALSE, 2);
  gtk_widget_show (lbl);

  entry = gtk_entry_new ();
  gtk_box_pack_start (GTK_BOX (hboxer), entry, FALSE, FALSE, 2);
  gtk_widget_show (entry);

  gtk_box_pack_start (GTK_BOX (lboxer), hboxer, FALSE, FALSE, 2);
  gtk_widget_show (hboxer);

  hboxer = gtk_hbox_new (FALSE, 1);
  hbutton = gtk_button_new_with_label ("Ok");
  gtk_box_pack_start (GTK_BOX (hboxer), hbutton, TRUE, TRUE, 2);
  gtk_widget_show (hbutton);

  gtk_signal_connect_object (GTK_OBJECT (hbutton), "clicked", GTK_SIGNAL_FUNC (go_line_exec), GTK_OBJECT (entry));

  gtk_signal_connect_object_after (GTK_OBJECT (hbutton), "clicked", GTK_SIGNAL_FUNC (gtk_widget_destroy), GTK_OBJECT (lwind));

  hbutton = gtk_button_new_with_label ("Cancel");
  gtk_box_pack_start (GTK_BOX (hboxer), hbutton, TRUE, TRUE, 2);
  gtk_widget_show (hbutton);

  gtk_signal_connect_object (GTK_OBJECT (hbutton), "clicked", GTK_SIGNAL_FUNC (gtk_widget_destroy), GTK_OBJECT (lwind));

  gtk_box_pack_start (GTK_BOX (lboxer), hboxer, FALSE, FALSE, 2);
  gtk_widget_show (hboxer);

  gtk_widget_show (lwind);

}				/* fin de go_line() */
