/*  Web Designer
   Copyright (C) 1999  LADISLAS Willhem

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

   Author's email : zillprog@freesurf.fr

   snailmail : 
		    LADISLAS Willhem
		    2, rue du Serpolet
		    95490 VAUREAL
		    FRANCE
 */

/* functions contained in this file 
edit_file_exec
openfile2


*/

#include "webdesigner.h"

void 
edit_file_exec (void)
{
  openfile2 (projectfiles[clist_row2].path, FALSE, TRUE);
}				/* fin de edit_file_exec */


void 
import_file_exec (GtkWidget * w, GtkFileSelection * fs)
{
  gchar *filename;
  FILE *infile;

  filename = gtk_file_selection_get_filename (GTK_FILE_SELECTION (fs));

  if (filename[strlen (filename) - 1] == '/')
    { /* checks if it a directory path instead of a file path */
      gtk_widget_destroy (filew);
      merror ("No file have been selected !");
      return;
    }

  if ((infile = fopen (filename, "r")) == NULL)
    {
      merror ("Can't open file");
      return;
    }

  gtk_text_freeze (GTK_TEXT (sheet[curfile].text));

  if (infile)
    {
      char buffer[1024];
      int nchars;

      while (1)
	{
	  nchars = fread (buffer, 1, 1024, infile);
	  gtk_text_insert (GTK_TEXT (sheet[curfile].text), fixed_font, NULL,
			   NULL, buffer, nchars);

	  if (nchars < 1024)
	    break;
	}

      fclose (infile);
    }

  gtk_text_thaw (GTK_TEXT (sheet[curfile].text));

  gtk_widget_destroy (filew);
  gtk_statusbar_push (GTK_STATUSBAR (status_bar), context_id, "File imported...");
}				/* fin de import_file_exec() */

void 
import_file_dialog (void)
{

  filew = gtk_file_selection_new ("Import file...");

  /* Connect the ok_button to file_ok_sel function */
  gtk_signal_connect (GTK_OBJECT (GTK_FILE_SELECTION (filew)->ok_button), "clicked", (GtkSignalFunc) import_file_exec, filew);

  /* Connect the cancel_button to destroy the widget */
  gtk_signal_connect_object (GTK_OBJECT (GTK_FILE_SELECTION (filew)->cancel_button), "clicked", (GtkSignalFunc) gtk_widget_destroy, GTK_OBJECT (filew));

  gtk_widget_show (filew);

}				/* fin de import_file_dialog() */



void 
file_modified (void)
{
  if (sheet[curfile].saved == TRUE)
    {
      sheet[curfile].saved = FALSE;
      gtk_statusbar_push (GTK_STATUSBAR (file_status_bar), context_id, " State : file unsaved ");
    }

  if (GTK_IS_CLIST (clist))
    {
      refresh_clist ();
    }
}				/* fin de file_modified(); */


void 
savefile (void)
{
  FILE *infile;
  char *buf;
  gchar *fil;
  char bufferp[255];

  if (numfileopened == 0)
    return;

  if (sheet[curfile].acces == FALSE)
    {
      sprintf (bufferp, " File \"%s\" is read only ! ", sheet[curfile].fichier);
      fil = bufferp;
      merror (fil);
      return;
    }

  if (sheet[curfile].new == TRUE)
    {
      dialogsaveas ();
      return;
    }

/*
   if ((access(sheet[curfile].chemin,R_OK)) == 0) printf("\nread access : +\n");
   else {
   printf("\nread access : -\n");
   }

   if ((access(sheet[curfile].chemin,W_OK)) == 0) printf("\nwrite access : +\n");
   else {
   printf("\nwrite access : -\n");
   }

   if ((access(sheet[curfile].chemin,X_OK)) == 0) printf("\nexecute access : +\n");
   else {
   printf("\nexecute access : -\n");
   }
 */

  if ((infile = fopen (sheet[curfile].chemin, "w")) == NULL)
    {
      sprintf (bufferp, " Can't save file %s !", sheet[curfile].fichier);
      fil = bufferp;
      merror (fil);
      return;
    }

  buf = gtk_editable_get_chars (GTK_EDITABLE (sheet[curfile].text), 0, gtk_text_get_length (GTK_TEXT (sheet[curfile].text)));
  if (fputs (buf, infile) == EOF)
    {
      perror ("Error saving file");
      g_free (buf);
      fclose (infile);
      exit (-1);
    }
  if (sheet[curfile].acces == TRUE)
    fclose (infile);

  sheet[curfile].saved = TRUE;
  gtk_statusbar_push (GTK_STATUSBAR (file_status_bar), context_id, " State : file saved ");

}				/* fin de savefile() */

void 
close_primary (void)
{

  GtkWidget *closep_dialog;
  GtkWidget *closep_vbox;
  GtkWidget *closep_hbox;
  GtkWidget *closep_button;
  GtkWidget *closep_frame;
  GtkWidget *img;
  char bufferp[255];

  if (numfileopened == 0)
    return;

  if (sheet[curfile].saved == FALSE)
    {

      closep_dialog = gtk_window_new (GTK_WINDOW_DIALOG);
      gtk_window_set_title (GTK_WINDOW (closep_dialog), "Confirmation");

      closep_frame = gtk_frame_new ("");
      gtk_container_border_width (GTK_CONTAINER (closep_frame), 5);

      closep_vbox = gtk_vbox_new (FALSE, 1);
      closep_hbox = gtk_hbox_new (FALSE, 1);
      gtk_container_border_width (GTK_CONTAINER (closep_vbox), 2);
      gtk_container_add (GTK_CONTAINER (closep_dialog), closep_frame);
      gtk_container_add (GTK_CONTAINER (closep_frame), closep_vbox);
      gtk_widget_show (closep_vbox);
      gtk_widget_show (closep_frame);

      gtk_widget_set_usize (GTK_WIDGET (closep_frame), 300, 200);


      img = new_pixmap (13, window->window, &color);
      gtk_box_pack_start (GTK_BOX (closep_vbox), img, FALSE, FALSE, 5);
      gtk_widget_show (img);

      insert_space (closep_vbox);
      sprintf (bufferp, " File '%s' was not saved ! ", getname (sheet[curfile].chemin));
      insert_lbl (closep_vbox, bufferp);
      insert_space (closep_vbox);
      insert_lbl (closep_vbox, " Do you want to save ? ");

      closep_button = gtk_button_new_with_label ("Yes");
      gtk_box_pack_start (GTK_BOX (closep_hbox), closep_button, TRUE, TRUE, 2);
      gtk_widget_show (closep_button);
      gtk_signal_connect (GTK_OBJECT (closep_button), "clicked", GTK_SIGNAL_FUNC (savefile), NULL);

      gtk_signal_connect_object (GTK_OBJECT (closep_button), "clicked", GTK_SIGNAL_FUNC (gtk_widget_destroy), GTK_OBJECT (closep_dialog));

      closep_button = gtk_button_new_with_label ("No");
      gtk_box_pack_start (GTK_BOX (closep_hbox), closep_button, TRUE, TRUE, 2);
      gtk_widget_show (closep_button);
      gtk_signal_connect (GTK_OBJECT (closep_button), "clicked", GTK_SIGNAL_FUNC (close_file), NULL);

      gtk_signal_connect_object (GTK_OBJECT (closep_button), "clicked", GTK_SIGNAL_FUNC (gtk_widget_destroy), GTK_OBJECT (closep_dialog));

      closep_button = gtk_button_new_with_label ("Cancel");
      gtk_box_pack_start (GTK_BOX (closep_hbox), closep_button, TRUE, TRUE, 2);
      gtk_widget_show (closep_button);

      gtk_signal_connect_object (GTK_OBJECT (closep_button), "clicked", GTK_SIGNAL_FUNC (gtk_widget_destroy), GTK_OBJECT (closep_dialog));

      gtk_box_pack_end (GTK_BOX (closep_vbox), closep_hbox, FALSE, TRUE, 5);
      gtk_widget_show (closep_hbox);

      gtk_widget_show (closep_dialog);


      return;
    }
  else
    {
      close_file ();
    }
}				/* fin de close_primary */



void 
close_primary2 (void)
{

  GtkWidget *closep_dialog;
  GtkWidget *closep_vbox;
  GtkWidget *closep_hbox;
  GtkWidget *closep_button;
  GtkWidget *closep_frame;
  GtkWidget *img;
  char bufferp[255];

  if (numfileopened == 0)
    return;

  if (sheet[curfile].saved == FALSE)
    {

      closep_dialog = gtk_window_new (GTK_WINDOW_DIALOG);
      gtk_window_set_title (GTK_WINDOW (closep_dialog), "Confirmation");

      closep_frame = gtk_frame_new ("");
      gtk_container_border_width (GTK_CONTAINER (closep_frame), 5);

      closep_vbox = gtk_vbox_new (FALSE, 1);
      closep_hbox = gtk_hbox_new (FALSE, 1);
      gtk_container_border_width (GTK_CONTAINER (closep_vbox), 2);
      gtk_container_add (GTK_CONTAINER (closep_dialog), closep_frame);
      gtk_container_add (GTK_CONTAINER (closep_frame), closep_vbox);
      gtk_widget_show (closep_vbox);
      gtk_widget_show (closep_frame);

      gtk_widget_set_usize (GTK_WIDGET (closep_frame), 300, 200);


      img = new_pixmap (13, window->window, &color);
      gtk_box_pack_start (GTK_BOX (closep_vbox), img, FALSE, FALSE, 5);
      gtk_widget_show (img);

      insert_space (closep_vbox);
      sprintf (bufferp, " File '%s' was not saved ! ", getname (sheet[curfile].chemin));
      insert_lbl (closep_vbox, bufferp);
      insert_space (closep_vbox);
      insert_lbl (closep_vbox, " Do you want to save ? ");

      closep_button = gtk_button_new_with_label ("Yes");
      gtk_box_pack_start (GTK_BOX (closep_hbox), closep_button, TRUE, TRUE, 2);
      gtk_widget_show (closep_button);


      gtk_signal_connect_after (GTK_OBJECT (closep_button), "clicked", GTK_SIGNAL_FUNC (close_all_files), NULL);

      gtk_signal_connect (GTK_OBJECT (closep_button), "clicked", GTK_SIGNAL_FUNC (savefile), NULL);

      gtk_signal_connect_object (GTK_OBJECT (closep_button), "clicked", GTK_SIGNAL_FUNC (gtk_widget_destroy), GTK_OBJECT (closep_dialog));

      closep_button = gtk_button_new_with_label ("No");
      gtk_box_pack_start (GTK_BOX (closep_hbox), closep_button, TRUE, TRUE, 2);
      gtk_widget_show (closep_button);

      gtk_signal_connect (GTK_OBJECT (closep_button), "clicked", GTK_SIGNAL_FUNC (close_file), NULL);

      gtk_signal_connect (GTK_OBJECT (closep_button), "clicked", GTK_SIGNAL_FUNC (close_all_files), NULL);

      gtk_signal_connect_object (GTK_OBJECT (closep_button), "clicked", GTK_SIGNAL_FUNC (gtk_widget_destroy), GTK_OBJECT (closep_dialog));


      closep_button = gtk_button_new_with_label ("Cancel");
      gtk_box_pack_start (GTK_BOX (closep_hbox), closep_button, TRUE, TRUE, 2);
      gtk_widget_show (closep_button);

      gtk_signal_connect_object (GTK_OBJECT (closep_button), "clicked", GTK_SIGNAL_FUNC (gtk_widget_destroy), GTK_OBJECT (closep_dialog));

      gtk_box_pack_end (GTK_BOX (closep_vbox), closep_hbox, FALSE, TRUE, 5);
      gtk_widget_show (closep_hbox);

      gtk_widget_show (closep_dialog);
      return;
    }
  else
    {
      close_file ();
    }

}				/* fin de close_primary2() */



void 
close_file (void)
{
  int j;

  if (curfile == (numfileopened - 1))
    {
      if (numfileopened == 1)
	{
	  gtk_window_set_title (GTK_WINDOW (window), "Web Designer");
	  gtk_statusbar_push (GTK_STATUSBAR (file_status_bar), context_id, "                                                 ");
	  gtk_statusbar_push (GTK_STATUSBAR (coord_status_bar), context_id, "                                      ");
	  gtk_statusbar_push (GTK_STATUSBAR (status_bar), context_id, " Files closed ");
	}
      numfileopened = numfileopened - 1;
      gtk_notebook_remove_page (GTK_NOTEBOOK (notebook), curfile);

      return;
    }

  if ((numfileopened == 2) && (curfile == 0))
    {
      numfileopened = numfileopened - 1;
      sheet[0] = sheet[1];
      gtk_notebook_remove_page (GTK_NOTEBOOK (notebook), curfile);
      curfile = 0;
      gtk_notebook_set_page (GTK_NOTEBOOK (notebook), curfile);
      gtk_statusbar_push (GTK_STATUSBAR (status_bar), context_id, " File closed ");
      return;
    }

  for (j = curfile; j < (numfileopened - 1); j++)
    {
      sheet[j] = sheet[j + 1];
    }
  numfileopened = numfileopened - 1;
  j = numfileopened;
  gtk_notebook_remove_page (GTK_NOTEBOOK (notebook), curfile);
  numfileopened = j;
  gtk_notebook_set_page (GTK_NOTEBOOK (notebook), curfile);
  gtk_statusbar_push (GTK_STATUSBAR (status_bar), context_id, " File closed ");

}				/* fin de close_file() */


void 
close_all_files (void)
{
  if (numfileopened == 0) return;

 while (numfileopened>0) {
 close_file (); 
}
   return; 

}				/* fin de close_all_files(); */




void 
filesaveas (GtkWidget * w, GtkFileSelection * fs)
{
  FILE *infile;
  char *buff;
  char bufferp[255];
  gchar *path;
  gchar *filename;
  gchar *fil;

  path = gtk_file_selection_get_filename (GTK_FILE_SELECTION (fs));

  if (path[strlen (path) - 1] == '/')
    {		/* checks if it a directory path instead of a file path */
      gtk_widget_destroy (filew);
      merror ("No file has been selected !");
      return;
    }


  if ((infile = fopen (path, "w")) == NULL)
    {
      sprintf (bufferp, " Can't save file %s ! ", path);
      fil = bufferp;
      merror (fil);
      return;
    }

  chdir(getpath(path));

  sprintf (sheet[curfile].chemin, "%s", path);
  filename = getname (path);
  sprintf (sheet[curfile].fichier, "%s", filename);

  gtk_notebook_set_tab_label_text (GTK_NOTEBOOK (notebook), sheet[curfile].table, sheet[curfile].fichier);
  sprintf (bufferp, "Web Designer - %s", sheet[curfile].chemin);
  gtk_window_set_title (GTK_WINDOW (window), bufferp);

/* ici implmenter une fonction de vrification que le fichier existe pour demander  l'utilisateur s'il est sur de vouloir l'effacer */

  infile = fopen (sheet[curfile].chemin, "w+");

  buff = gtk_editable_get_chars (GTK_EDITABLE (sheet[curfile].text), 0, -1);

  fwrite (buff, gtk_text_get_length (GTK_TEXT (sheet[curfile].text)), 1, infile);
  fclose (infile);

  sheet[curfile].new = FALSE;

  sheet[curfile].saved = TRUE;
  gtk_statusbar_push (GTK_STATUSBAR (file_status_bar), context_id, " State : file saved ");

  gtk_widget_destroy (filew);
}				/* fin de filesaveas() */



void 
dialogsaveas (void)
{

  filew = gtk_file_selection_new ("Save as...");

  /* Connect the ok_button to file_ok_sel function */
  gtk_signal_connect (GTK_OBJECT (GTK_FILE_SELECTION (filew)->ok_button),
		      "clicked", (GtkSignalFunc) filesaveas, filew);

  /* Connect the cancel_button to destroy the widget */
  gtk_signal_connect_object (GTK_OBJECT (GTK_FILE_SELECTION (filew)->cancel_button), "clicked", (GtkSignalFunc) gtk_widget_destroy, GTK_OBJECT (filew));

  /* Lets set the default filename */
  gtk_file_selection_set_filename (GTK_FILE_SELECTION (filew), "document1.html");

  gtk_widget_show (filew);
}				/* fin de dialogsaveas() */




void 
text_toggle_editable (void)
{
  if (editok == 1)
    {
      gtk_text_set_editable (GTK_TEXT (sheet[curfile].text), FALSE);
      editok = 0;
    }
  else
    {
      gtk_text_set_editable (GTK_TEXT (sheet[curfile].text), TRUE);
      editok = 1;
    }
}


void 
text_toggle_word_wrap (void)
{
  if (wrapok == 1)
    {
      gtk_text_set_word_wrap (GTK_TEXT (sheet[curfile].text), FALSE);
      wrapok = 0;
    }
  else
    {
      gtk_text_set_word_wrap (GTK_TEXT (sheet[curfile].text), TRUE);
      wrapok = 1;
    }
}


void 
nfile (GtkWidget * w, GtkFileSelection * fs)
{


  GtkWidget *label;
  char bufferp[255];
  FILE *infile;
  gchar *path;
  gchar *filename;
  gchar *fil;
  gboolean acc;
  gboolean in = FALSE;
  int i;

  path = gtk_file_selection_get_filename (GTK_FILE_SELECTION (fs));

/* checks if it a directory path instead of a file path */

  if (path[strlen (path) - 1] == '/')
    {
      gtk_widget_destroy (filew);
      merror ("No file has been selected !");
      return;
    }

  if ((access (path, R_OK)) != 0)
    {
      sprintf (bufferp, " Can't open file %s ! ", path);
      fil = bufferp;
      merror (fil);
      return;
    }

  if ((access (path, W_OK)) != 0)
    acc = FALSE;
  else
    {
      acc = TRUE;
    }

  infile = fopen (path, "r");

  chdir(getpath(path));

  numfileopened = numfileopened + 1;
  updatefilelist (0);
  curfile = 0;

  sheet[curfile].new = FALSE;
  sheet[curfile].acces = acc;
  sheet[curfile].saved = TRUE;
  sheet[curfile].inprj = FALSE;



/* get the file type and put it in the adequate variable */
  filename = getext (path);
  sprintf (sheet[curfile].type, "%s", filename);


  sprintf (sheet[curfile].chemin, "%s", path);
  filename = getname (path);
  sprintf (sheet[curfile].fichier, "%s", filename);


  sheet[curfile].table = gtk_table_new (2, 2, FALSE);
  gtk_table_set_row_spacing (GTK_TABLE (sheet[curfile].table), 0, 2);
  gtk_table_set_col_spacing (GTK_TABLE (sheet[curfile].table), 0, 2);
  sprintf (bufferp, "Web Designer - %s", sheet[curfile].chemin);
  gtk_widget_show (sheet[curfile].table);

  gtk_window_set_title (GTK_WINDOW (window), bufferp);

  label = gtk_label_new (sheet[curfile].fichier);

  gtk_notebook_prepend_page (GTK_NOTEBOOK (notebook), sheet[curfile].table, label);

/* Create the GtkText widget */
  sheet[curfile].text = gtk_text_new (NULL, NULL);

  if (sheet[curfile].acces == TRUE)
    {
      gtk_text_set_editable (GTK_TEXT (sheet[curfile].text), TRUE);
    }
  else
    {
      gtk_text_set_editable (GTK_TEXT (sheet[curfile].text), FALSE);
    }

  gtk_table_attach (GTK_TABLE (sheet[curfile].table), sheet[curfile].text, 0, 1, 0, 1,
		    GTK_EXPAND | GTK_SHRINK | GTK_FILL,
		    GTK_EXPAND | GTK_SHRINK | GTK_FILL, 0, 0);
  gtk_widget_show (sheet[curfile].text);

/*  Add a vertical scrollbar to the GtkText widget */
  sheet[curfile].vscrollbar = gtk_vscrollbar_new (GTK_TEXT (sheet[curfile].text)->vadj);
  gtk_table_attach (GTK_TABLE (sheet[curfile].table), sheet[curfile].vscrollbar, 1, 2, 0, 1,
		    GTK_FILL, GTK_EXPAND | GTK_SHRINK | GTK_FILL, 0, 0);
  gtk_widget_show (sheet[curfile].vscrollbar);


/* Add a horizontal scrollbar to the GtkText widget (not used yet because 
   the text and hscrollbar widgets are not up to date !) 

   hscrollbar = gtk_hscrollbar_new (GTK_TEXT (sheet[curfile].text)->hadj);
   gtk_table_attach (GTK_TABLE (sheet[curfile].table), hscrollbar, 0, 1, 1, 2,
   GTK_FILL | GTK_EXPAND | GTK_SHRINK, GTK_FILL, 0, 0);
   gtk_widget_show (hscrollbar);
 */

  gtk_widget_realize (sheet[curfile].text);

/* Freeze the text widget, ready for multiple updates */
  gtk_text_freeze (GTK_TEXT (sheet[curfile].text));


  if (infile)
    {
      char buffer[1024];
      int nchars;
      colour = black;
      if (!strcmp (sheet[curfile].type, "htm") || !strcmp (sheet[curfile].type, "html") || !strcmp (sheet[curfile].type, "shtml"))
	{
	  while (1)
	    {
	      nchars = fread (buffer, 1, 1024, infile);
	      for (i = 0; i < nchars; i++)
		{
		  if ((isdigit (buffer[i])) != 0 && intag == TRUE)
		    {
		      gtk_text_insert (GTK_TEXT (sheet[curfile].text), fixed_font, &red, NULL, &buffer[i], 1);
		      goto suiteb2;
		    }

		  if (buffer[i] == '<')
		    {
		      colour = blue;
		      intag = TRUE;
		    }

		  if (buffer[i] == '>')
		    {
		      gtk_text_insert (GTK_TEXT (sheet[curfile].text), fixed_font, &colour, NULL, &buffer[i], 1);
		      colour = black;
		      intag = FALSE;
		      goto suiteb2;
		    }

		  if (buffer[i] == '"')
		    {

		      if (in == TRUE)
			{
			  gtk_text_insert (GTK_TEXT (sheet[curfile].text), fixed_font, &colour, NULL, &buffer[i], 1);
			  colour = savecol;
			  in = FALSE;
			  goto suiteb2;
			}

		      if (in == FALSE)
			{
			  savecol = colour;
			  colour = green;
			  in = TRUE;
			}
		    }

		  gtk_text_insert (GTK_TEXT (sheet[curfile].text), fixed_font, &colour,
				   NULL, &buffer[i], 1);
		suiteb2:
		}		/* fin de for.. */
	      if (nchars < 1024)
		break;

	    }			/* fin de while(1) */
	}			/* fin de type de fichier */

      else if (!strcmp (sheet[curfile].type, "c") || !strcmp (sheet[curfile].type, "cpp") || !strcmp (sheet[curfile].type, "c++") || !strcmp (sheet[curfile].type, "h"))
	{
	  while (1)
	    {
	      nchars = fread (buffer, 1, 1024, infile);
	      for (i = 0; i < nchars; i++)
		{
		  if ((isdigit (buffer[i])) != 0 || buffer[i] == '(' || buffer[i] == ')')
		    {
		      gtk_text_insert (GTK_TEXT (sheet[curfile].text), fixed_font, &red, NULL, &buffer[i], 1);
		      goto suitebe2;
		    }

		  if (buffer[i] == '#')
		    {
		      colour = blue;
		      diese = TRUE;
		    }

		  if (buffer[i] == '\n' && diese == TRUE)
		    {
		      colour = black;
		      diese = FALSE;
		    }
/* I think this can bring us into troubles... */
		  if (buffer[i] == '/' && buffer[i + 1] == '*')
		    {
		      colour = green;
		    }

		  if (i != 0 && buffer[i] == '/' && buffer[i - 1] == '*')
		    {
		      gtk_text_insert (GTK_TEXT (sheet[curfile].text), fixed_font, &green, NULL, &buffer[i], 1);
		      colour = black;
		      goto suitebe2;
		    }


		  if ((buffer[i] == ';') || (buffer[i] == '{') || (buffer[i] == '}') || (buffer[i] == '+') || (buffer[i] == '-') || (buffer[i] == '[') || (buffer[i] == ']') || (buffer[i] == '=') || (buffer[i] == '/') || (buffer[i] == '\\') || (buffer[i] == ',') || (buffer[i] == '&') || buffer[i] == '.' || buffer[i] == '*')
		    {
		      gtk_text_insert (GTK_TEXT (sheet[curfile].text), fixed_font, &blue, NULL, &buffer[i], 1);
		      goto suitebe2;
		    }

		  if (buffer[i] == '"')
		    {

		      if (in == TRUE)
			{
			  gtk_text_insert (GTK_TEXT (sheet[curfile].text), fixed_font, &colour, NULL, &buffer[i], 1);
			  colour = savecol;
			  in = FALSE;
			  goto suitebe2;
			}

		      if (in == FALSE)
			{
			  savecol = colour;
			  colour = green;
			  in = TRUE;
			}
		    }

		  gtk_text_insert (GTK_TEXT (sheet[curfile].text), fixed_font, &colour,
				   NULL, &buffer[i], 1);
		suitebe2:
		}		/* fin de for.. */
	      if (nchars < 1024)
		break;
	    }			/* fin de while(1) */

	}			/* fin de else if */

      else
	{
	  while (1)
	    {
	      nchars = fread (buffer, 1, 1024, infile);
	      gtk_text_insert (GTK_TEXT (sheet[curfile].text), fixed_font, NULL, NULL, buffer, nchars);

	      if (nchars < 1024)
		break;
	    }			/* fin de while(1) */

	}			/* fin de else */

      fclose (infile);

    }				/* fin de infile */

gtk_text_thaw (GTK_TEXT (sheet[curfile].text));
  colour = black;


  gtk_notebook_set_page (GTK_NOTEBOOK (notebook), 0);
  gtk_widget_destroy (filew);


  gtk_signal_connect_object(GTK_OBJECT (sheet[curfile].text), "event",
		      GTK_SIGNAL_FUNC (button_press), GTK_OBJECT (popmenu));

  gtk_signal_connect_object(GTK_OBJECT (sheet[curfile].text), "insert_text",
	      GTK_SIGNAL_FUNC (inst_txt), GTK_OBJECT (sheet[curfile].text));

  gtk_signal_connect_object (GTK_OBJECT (sheet[curfile].text), "changed",
		 GTK_SIGNAL_FUNC (file_modified), NULL);


/*   gtk_signal_connect_object(GTK_OBJECT(sheet[curfile].text), "event",
   GTK_SIGNAL_FUNC (coord), GTK_OBJECT(sheet[curfile].text)); */
   
  gtk_statusbar_push (GTK_STATUSBAR (status_bar), context_id, "File opened");

}				/* fin de nfile() */


int 
openfile2 (gchar * filepath, gboolean nouveau, gboolean prj)
{


  GtkWidget *label;
  char bufferp[255];
  FILE *infile;
  gboolean in = FALSE;
  int i;
  gchar *filename;
  gchar *fil;

  if (nouveau == TRUE)
    {
      infile = fopen (filepath, "r");
      goto suite;
    }

  if ((access (filepath, R_OK)) != 0)
    {
      sprintf (bufferp, " Can't open file %s ! ", filepath);
      fil = bufferp;
      merror (fil);
      return 0;
    }

  infile = fopen (filepath, "r");

  chdir(getpath(filepath));

suite:
  numfileopened = numfileopened + 1;
  updatefilelist (0);
  curfile = 0;

  if (nouveau == TRUE)
    {
      sheet[curfile].new = TRUE;
      sheet[curfile].inprj = FALSE;
    }
  else
    {
      sheet[curfile].new = FALSE;
      sheet[curfile].inprj = TRUE;
    }

  sheet[curfile].saved = TRUE;
  sheet[curfile].acces = TRUE;

  sprintf (sheet[curfile].chemin, "%s", filepath);

/* get the file type and put it in the adequate variable */
  filename = getext (filepath);
  sprintf (sheet[curfile].type, "%s", filename);

#ifdef debugging

  printf ("%s\n", sheet[curfile].type);

#endif

/* get the file name and put it in the adequate variable */
  filename = getname (filepath);
  sprintf (sheet[curfile].fichier, "%s", filename);


  sheet[curfile].table = gtk_table_new (2, 2, FALSE);
  gtk_table_set_row_spacing (GTK_TABLE (sheet[curfile].table), 0, 2);
  gtk_table_set_col_spacing (GTK_TABLE (sheet[curfile].table), 0, 2);
  sprintf (bufferp, "Web Designer - %s", sheet[curfile].chemin);
  gtk_widget_show (sheet[curfile].table);

  gtk_window_set_title (GTK_WINDOW (window), bufferp);

  label = gtk_label_new (sheet[curfile].fichier);

  gtk_notebook_prepend_page (GTK_NOTEBOOK (notebook), sheet[curfile].table, label);

/* Create the GtkText widget */

  sheet[curfile].text = gtk_text_new (NULL, NULL);
  gtk_text_set_editable (GTK_TEXT (sheet[curfile].text), TRUE);
  gtk_table_attach (GTK_TABLE (sheet[curfile].table), sheet[curfile].text, 0, 1, 0, 1,
		    GTK_EXPAND | GTK_SHRINK | GTK_FILL,
		    GTK_EXPAND | GTK_SHRINK | GTK_FILL, 0, 0);
  gtk_widget_show (sheet[curfile].text);

/*  Add a vertical scrollbar to the GtkText widget */

  sheet[curfile].vscrollbar = gtk_vscrollbar_new (GTK_TEXT (sheet[curfile].text)->vadj);
  gtk_table_attach (GTK_TABLE (sheet[curfile].table), sheet[curfile].vscrollbar, 1, 2, 0, 1,
		    GTK_FILL, GTK_EXPAND | GTK_SHRINK | GTK_FILL, 0, 0);
  gtk_widget_show (sheet[curfile].vscrollbar);


/* Add a horizontal scrollbar to the GtkText widget (not used yet because 
   the text and hscrollbar widgets are not up to date !) 

   hscrollbar = gtk_hscrollbar_new (GTK_TEXT (sheet[curfile].text)->hadj);
   gtk_table_attach (GTK_TABLE (sheet[curfile].table), hscrollbar, 0, 1, 1, 2,
   GTK_FILL | GTK_EXPAND | GTK_SHRINK, GTK_FILL, 0, 0);
   gtk_widget_show (hscrollbar);
*/

  gtk_widget_realize (sheet[curfile].text);

/* Freeze the text widget, ready for multiple updates */
  gtk_text_freeze (GTK_TEXT (sheet[curfile].text));

  if (infile)
    {
      char buffer[1024];
      int nchars;
      colour = black;

      if (!strcmp (sheet[curfile].type, "htm") || !strcmp (sheet[curfile].type, "html") || !strcmp (sheet[curfile].type, "shtml"))
	{
	  while (1)
	    {
	      nchars = fread (buffer, 1, 1024, infile);
	      for (i = 0; i < nchars; i++)
		{
		  if ((isdigit (buffer[i])) != 0 && intag == TRUE)
		    {
		      gtk_text_insert (GTK_TEXT (sheet[curfile].text), fixed_font, &red, NULL, &buffer[i], 1);
		      goto suiteb;
		    }

		  if (buffer[i] == '<')
		    {
		      colour = blue;
		      intag = TRUE;
		    }

		  if (buffer[i] == '>')
		    {
		      gtk_text_insert (GTK_TEXT (sheet[curfile].text), fixed_font, &colour, NULL, &buffer[i], 1);
		      colour = black;
		      intag = FALSE;
		      goto suiteb;
		    }

		  if (buffer[i] == '"')
		    {

		      if (in == TRUE)
			{
			  gtk_text_insert (GTK_TEXT (sheet[curfile].text), fixed_font, &colour, NULL, &buffer[i], 1);
			  colour = savecol;
			  in = FALSE;
			  goto suiteb;
			}

		      if (in == FALSE)
			{
			  savecol = colour;
			  colour = green;
			  in = TRUE;
			}
		    }

		  gtk_text_insert (GTK_TEXT (sheet[curfile].text), fixed_font, &colour,
				   NULL, &buffer[i], 1);
		suiteb:
		}		/* fin de for.. */
	      if (nchars < 1024)
		break;

	    }			/* fin de while(1) */
	}			/* fin de type de fichier */

      else if (!strcmp (sheet[curfile].type, "c") || !strcmp (sheet[curfile].type, "cpp") || !strcmp (sheet[curfile].type, "c++") || !strcmp (sheet[curfile].type, "h"))
	{
	  while (1)
	    {
	      nchars = fread (buffer, 1, 1024, infile);
	      for (i = 0; i < nchars; i++)
		{
		  if ((isdigit (buffer[i])) != 0 || buffer[i] == '(' || buffer[i] == ')')
		    {
		      gtk_text_insert (GTK_TEXT (sheet[curfile].text), fixed_font, &red, NULL, &buffer[i], 1);
		      goto suitebe;
		    }

		  if (buffer[i] == '#')
		    {
		      colour = blue;
		      diese = TRUE;
		    }

		  if (buffer[i] == '\n' && diese == TRUE)
		    {
		      colour = black;
		      diese = FALSE;
		    }
/* I think this can bring us into troubles... */
		  if (buffer[i] == '/' && buffer[i + 1] == '*')
		    {
		      colour = green;
		    }

		  if (i != 0 && buffer[i] == '/' && buffer[i - 1] == '*')
		    {
		      gtk_text_insert (GTK_TEXT (sheet[curfile].text), fixed_font, &green, NULL, &buffer[i], 1);
		      colour = black;
		      goto suitebe;
		    }

		  if (buffer[i] == ';' || buffer[i] == '{' || buffer[i] == '}' || buffer[i] == '+' || buffer[i] == '-' || buffer[i] == '[' || buffer[i] == ']' || buffer[i] == '=' || buffer[i] == '/' || buffer[i] == '\\' || buffer[i] == ',' || buffer[i] == '&' || buffer[i] == '.' || buffer[i] == '*')
		    {
		      gtk_text_insert (GTK_TEXT (sheet[curfile].text), fixed_font, &blue, NULL, &buffer[i], 1);
		      goto suitebe;
		    }

		  if (buffer[i] == '"')
		    {

		      if (in == TRUE)
			{
			  gtk_text_insert (GTK_TEXT (sheet[curfile].text), fixed_font, &colour, NULL, &buffer[i], 1);
			  colour = savecol;
			  in = FALSE;
			  goto suitebe;
			}

		      if (in == FALSE)
			{
			  savecol = colour;
			  colour = green;
			  in = TRUE;
			}
		    }

		  gtk_text_insert (GTK_TEXT (sheet[curfile].text), fixed_font, &colour,
				   NULL, &buffer[i], 1);
		suitebe:
		}		/* fin de for.. */
	      if (nchars < 1024)
		break;
	    }			/* fin de while(1) */

	}			/* fin de else if */

      else
	{
	  while (1)
	    {
	      nchars = fread (buffer, 1, 1024, infile);
	      gtk_text_insert (GTK_TEXT (sheet[curfile].text), fixed_font, NULL, NULL, buffer, nchars);

	      if (nchars < 1024)
		break;
	    }			/* fin de while(1) */

	}			/* fin de else */

      fclose (infile);

    }				/* fin de (infile) */

  gtk_text_insert (GTK_TEXT (sheet[curfile].text), fixed_font, NULL,
		   NULL, " ", -1);
  gtk_text_backward_delete (GTK_TEXT (sheet[curfile].text), 1);


  gtk_text_thaw (GTK_TEXT (sheet[curfile].text));

  gtk_notebook_set_page (GTK_NOTEBOOK (notebook), 0);

/* petite ambiguit ici, car la fonction coord (lance par button press coord) lance la fonction file_modified() qui indique que le fichier a t modifi (alors qu'un simple clic ne le modifie pas !... */

  gtk_signal_connect_object (GTK_OBJECT (sheet[curfile].text), "event",
		      GTK_SIGNAL_FUNC (button_press), GTK_OBJECT (popmenu));


  gtk_signal_connect_object (GTK_OBJECT (sheet[curfile].text), "insert_text",
	      GTK_SIGNAL_FUNC (inst_txt), GTK_OBJECT (sheet[curfile].text));

/*   gtk_signal_connect_object(GTK_OBJECT(sheet[curfile].text), "event",
   GTK_SIGNAL_FUNC (coord), GTK_OBJECT(sheet[curfile].text)); */

  gtk_signal_connect_object (GTK_OBJECT (sheet[curfile].text), "changed",
		 GTK_SIGNAL_FUNC (  file_modified ), NULL);

  gtk_statusbar_push (GTK_STATUSBAR (status_bar), context_id, "File opened");

  return 1;
}				/* fin de openfile2() */


void 
newfile (void)
{
  openfile2 ("~/Document", TRUE, FALSE);
}				/* fin de newfile(); */



void 
openfile (void)
{

  /* Create a new file selection widget */
  filew = gtk_file_selection_new ("Open file...");

  /* Connect the ok_button to file_ok_sel function */
  gtk_signal_connect (GTK_OBJECT (GTK_FILE_SELECTION (filew)->ok_button),
		      "clicked", (GtkSignalFunc) nfile, GTK_OBJECT (filew));

  /* Connect the cancel_button to destroy the widget */
  gtk_signal_connect_object (GTK_OBJECT (GTK_FILE_SELECTION (filew)->cancel_button),
			     "clicked", (GtkSignalFunc) gtk_widget_destroy,
			     GTK_OBJECT (filew));

  gtk_widget_show (filew);

}				/* fin de openfile */
