/*  Web Designer
   Copyright (C) 1999  LADISLAS Willhem

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

   Author's email : zillprog@freesurf.fr

   snailmail :      LADISLAS Willhem
   2, rue du Serpolet
   95490 VAUREAL
   FRANCE
 */

#include <gtk-xmhtml/gtk-xmhtml.h>
#include <gtk-xmhtml/HTML.h>
#include "misc.h"


void 
tab_window_toggle (void)
{

  if (tab_activ == TRUE)
    {
      tab_activ = FALSE;
      gtk_widget_hide (hbox2);
    }
  else
    {
      tab_activ = TRUE;
      gtk_widget_show (hbox2);
    }

}				/* fin de tab_window_toggle */

void
widget_style (GtkWidget * wgt)
{
  GtkStyle *style;

  style = gtk_style_copy (wgt->style);

  style->base[GTK_STATE_NORMAL].red = 0xffff;
  style->base[GTK_STATE_NORMAL].blue = 0xcfff;
  style->base[GTK_STATE_NORMAL].green = 0xffff;


  gtk_widget_set_style (wgt, style);

  gtk_widget_pop_style ();
}				/* fin de wigdet_style */

char *
getpath (char *path)
{
  int i;
  char *buffer;

  i = strlen (path) - 1;
  if (i > -1)
    while (path[i] != '/' && i > 0)
      i--;

  buffer = (char *) malloc (i + 1);
  strncpy (buffer, path, i);
  buffer[i] = '\0';

  return buffer;
}				/* fin de getpath */


void
display_file_info (void)
{
  GtkWidget *file_info_window;
  GtkWidget *file_info_vbox;
  GtkWidget *file_info_frame;
  GtkWidget *file_info_text;
  GtkWidget *buttonOk;
  int length;
  char bufferp[255];

  if (numfileopened == 0)
    return;

  file_info_window = gtk_window_new (GTK_WINDOW_DIALOG);
  gtk_widget_set_usize (GTK_WIDGET (file_info_window), 500, 270);
  gtk_window_set_title (GTK_WINDOW (file_info_window), "File informations");

  file_info_frame = gtk_frame_new (" Informations ");
  gtk_container_border_width (GTK_CONTAINER (file_info_frame), 10);
  gtk_container_add (GTK_CONTAINER (file_info_window), file_info_frame);

  file_info_vbox = gtk_vbox_new (FALSE, 1);
  gtk_container_border_width (GTK_CONTAINER (file_info_vbox), 2);
  gtk_container_add (GTK_CONTAINER (file_info_frame), file_info_vbox);

  gtk_widget_show (file_info_vbox);
  gtk_widget_show (file_info_frame);

  file_info_text = gtk_text_new (NULL, NULL);
  gtk_box_pack_start (GTK_BOX (file_info_vbox), file_info_text, TRUE, TRUE, 5);
  gtk_widget_show (file_info_text);


  gtk_text_freeze (GTK_TEXT (file_info_text));
  gtk_text_insert (GTK_TEXT (file_info_text), fixed_font, NULL, NULL, "\n File            : ", -1);
  gtk_text_insert (GTK_TEXT (file_info_text), fixed_font, NULL, NULL, sheet[curfile].chemin, -1);

  if (sheet[curfile].saved == TRUE)
    {
      gtk_text_insert (GTK_TEXT (file_info_text), fixed_font, NULL, NULL, "\n\n Modified            : yes ", -1);
    }
  else
    {
      gtk_text_insert (GTK_TEXT (file_info_text), fixed_font, NULL, NULL, "\n\n Modified            : no ", -1);
    }

  if (sheet[curfile].new == TRUE)
    {
      gtk_text_insert (GTK_TEXT (file_info_text), fixed_font, NULL, NULL, "\n Read access   : yes ", -1);
      gtk_text_insert (GTK_TEXT (file_info_text), fixed_font, NULL, NULL, "\n Write access  : yes ", -1);
      gtk_text_insert (GTK_TEXT (file_info_text), fixed_font, NULL, NULL, "\n Execute access : no", -1);
      goto sut;
    }

  if ((access (sheet[curfile].chemin, R_OK)) == 0)
    {
      gtk_text_insert (GTK_TEXT (file_info_text), fixed_font, NULL, NULL, "\n Read access   : yes  ", -1);
    }
  else
    {
      gtk_text_insert (GTK_TEXT (file_info_text), fixed_font, NULL, NULL, "\n Read access  : no ", -1);
    }

  if ((access (sheet[curfile].chemin, W_OK)) == 0)
    {
      gtk_text_insert (GTK_TEXT (file_info_text), fixed_font, NULL, NULL, "\n Write access  : yes ", -1);
    }
  else
    {
      gtk_text_insert (GTK_TEXT (file_info_text), fixed_font, NULL, NULL, "\n Write access  : no ", -1);
    }

  if ((access (sheet[curfile].chemin, X_OK)) == 0)
    {
      gtk_text_insert (GTK_TEXT (file_info_text), fixed_font, NULL, NULL, "\n Execute access  : yes", -1);
    }
  else
    {
      gtk_text_insert (GTK_TEXT (file_info_text), fixed_font, NULL, NULL, "\n Execute access  : no", -1);
    }

sut:
  length = gtk_text_get_length (GTK_TEXT (sheet[curfile].text));
  sprintf (bufferp, "\n Size in memmory  : %d\n\n", length);
  gtk_text_insert (GTK_TEXT (file_info_text), fixed_font, NULL, NULL, bufferp, -1);


  buttonOk = gtk_button_new_with_label ("Close");
  gtk_box_pack_start (GTK_BOX (file_info_vbox), buttonOk, FALSE, FALSE, 5);
  gtk_widget_show (buttonOk);

  gtk_text_thaw (GTK_TEXT (file_info_text));
  gtk_widget_show (file_info_window);

  gtk_signal_connect_object (GTK_OBJECT (buttonOk), "clicked", GTK_SIGNAL_FUNC (gtk_widget_destroy), GTK_OBJECT (file_info_window));

}				/* fin de display_file_info */


void
print_file_exec (GtkWidget * widget, gpointer data)
{
  gchar *entxt, *commandln;

  entxt = gtk_entry_get_text (GTK_ENTRY (widget));
  commandln = (char *) malloc (512);

  sprintf (commandln, entxt, sheet[curfile].chemin);

  system (commandln);
  free(commandln);
  gtk_widget_destroy (dialog_window);
}				/* fin de print_file_exec */

void
print_file (void)
{
  GtkWidget *print_vbox;
  GtkWidget *print_entry;
  GtkWidget *print_frame;
  GtkWidget *print_hbox;
  GtkWidget *buttonOk;
  GtkWidget *buttonCancel;
  GtkWidget *img;
  char * bufferp;

  if (numfileopened == 0)
    return;

  dialog_window = gtk_window_new (GTK_WINDOW_DIALOG);

  bufferp = (char *) malloc(512);

  sprintf (bufferp, "Printing of '%s'", sheet[curfile].fichier);

  gtk_window_set_title (GTK_WINDOW (dialog_window), bufferp);
  gtk_widget_set_usize (dialog_window, 300, 305);

  print_frame = gtk_frame_new (" Print options ");
  gtk_container_border_width (GTK_CONTAINER (print_frame), 10);


  print_vbox = gtk_vbox_new (FALSE, 1);
  gtk_container_border_width (GTK_CONTAINER (print_vbox), 5);
  gtk_container_add (GTK_CONTAINER (dialog_window), print_frame);
  gtk_container_add (GTK_CONTAINER (print_frame), print_vbox);
  gtk_widget_show (print_vbox);
  gtk_widget_show (print_frame);

  img = new_pixmap (20, window->window, &color);
  gtk_box_pack_start (GTK_BOX (print_vbox), img, FALSE, FALSE, 5);
  gtk_widget_show (img);


  insert_space (print_vbox);
  insert_lbl (print_vbox, "Insert your printing command :");
  insert_lbl (print_vbox, " '%s' stands for the file name");
  insert_space (print_vbox);
  print_entry = gtk_entry_new_with_max_length (255);
  gtk_entry_set_text (GTK_ENTRY (print_entry), "lpr %s");
  gtk_box_pack_start (GTK_BOX (print_vbox), print_entry, FALSE, FALSE, 5);
  gtk_widget_show (print_entry);

  insert_space (print_vbox);
  print_hbox = gtk_hbox_new (FALSE, 1);
  gtk_box_pack_start (GTK_BOX (print_vbox), print_hbox, FALSE, TRUE, 5);
  gtk_widget_show (print_hbox);

  buttonOk = gtk_button_new_with_label ("Print");
  buttonCancel = gtk_button_new_with_label ("Cancel");

  gtk_box_pack_start (GTK_BOX (print_hbox), buttonOk, TRUE, TRUE, 5);
  gtk_box_pack_start (GTK_BOX (print_hbox), buttonCancel, TRUE, TRUE, 5);
  gtk_widget_show (buttonCancel);
  gtk_widget_show (buttonOk);

  gtk_widget_show (dialog_window);
  free(bufferp);

  gtk_signal_connect_object (GTK_OBJECT (buttonCancel), "clicked", GTK_SIGNAL_FUNC (gtk_widget_destroy), GTK_OBJECT (dialog_window));

  gtk_signal_connect (GTK_OBJECT (dialog_window), "destroy", GTK_SIGNAL_FUNC (gtk_widget_destroy), GTK_OBJECT (dialog_window));

  gtk_signal_connect_object (GTK_OBJECT (buttonOk), "clicked", GTK_SIGNAL_FUNC (print_file_exec), GTK_OBJECT (print_entry));

}				/* fin de print_file() */


void
helpwindow (void)
{

}				/* fin de helpwindow(void) */

void
toggle_tab_pos(GtkWidget * w, int Opcode)
{
gtk_notebook_set_tab_pos (GTK_NOTEBOOK(notebook),  Opcode);
} /* fin de toggle_tab_pos */


void set_browser_path(GtkWidget *widget, gpointer data)
{
  char * commd;

  commd = gtk_entry_get_text (GTK_ENTRY (widget));
  sprintf(browser_command, commd, sheet[curfile].chemin);

  gtk_widget_destroy (dialog_window);
} /* fin de set_browser_path */


void
browser_path (void)
{

/* don't follow the variables names it has been copied from the function for print */
  GtkWidget *print_vbox;
  GtkWidget *print_entry;
  GtkWidget *print_frame;
  GtkWidget *print_hbox;
  GtkWidget *buttonOk;
  GtkWidget *buttonCancel;
  char * bufferp;

  if (numfileopened == 0)
    return;

  dialog_window = gtk_window_new (GTK_WINDOW_DIALOG);
  bufferp = "Browser path";

  gtk_window_set_title (GTK_WINDOW (dialog_window), bufferp);
  gtk_widget_set_usize (dialog_window, 300, 185);

  print_frame = gtk_frame_new (" Browser path ");
  gtk_container_border_width (GTK_CONTAINER (print_frame), 10);


  print_vbox = gtk_vbox_new (FALSE, 1);
  gtk_container_border_width (GTK_CONTAINER (print_vbox), 5);
  gtk_container_add (GTK_CONTAINER (dialog_window), print_frame);
  gtk_container_add (GTK_CONTAINER (print_frame), print_vbox);
  gtk_widget_show (print_vbox);
  gtk_widget_show (print_frame);

  insert_space (print_vbox);
  insert_lbl (print_vbox, "Insert your browser path :");
  insert_lbl (print_vbox, " '%s' stands for the file name");
  insert_space (print_vbox);
  print_entry = gtk_entry_new_with_max_length (255);
  gtk_entry_set_text (GTK_ENTRY (print_entry), "/usr/bin/netscape %s");
  gtk_box_pack_start (GTK_BOX (print_vbox), print_entry, FALSE, FALSE, 5);
  gtk_widget_show (print_entry);

  insert_space (print_vbox);
  print_hbox = gtk_hbox_new (FALSE, 1);
  gtk_box_pack_start (GTK_BOX (print_vbox), print_hbox, FALSE, TRUE, 5);
  gtk_widget_show (print_hbox);

  buttonOk = gtk_button_new_with_label ("Ok");
  buttonCancel = gtk_button_new_with_label ("Cancel");

  gtk_box_pack_start (GTK_BOX (print_hbox), buttonOk, TRUE, TRUE, 5);
  gtk_box_pack_start (GTK_BOX (print_hbox), buttonCancel, TRUE, TRUE, 5);
  gtk_widget_show (buttonCancel);
  gtk_widget_show (buttonOk);

  gtk_widget_show (dialog_window);

  gtk_signal_connect_object (GTK_OBJECT (buttonOk), "clicked", GTK_SIGNAL_FUNC (set_browser_path), GTK_OBJECT (print_entry));

  gtk_signal_connect_object (GTK_OBJECT (buttonCancel), "clicked", GTK_SIGNAL_FUNC (gtk_widget_destroy), GTK_OBJECT (dialog_window));

  gtk_signal_connect (GTK_OBJECT (dialog_window), "destroy", GTK_SIGNAL_FUNC (gtk_widget_destroy), GTK_OBJECT (dialog_window));

}			/* fin de browser_path() */


void
config (void)
{

} /* fin de config */

void
insert_date (void)
{
/*
   GtkWidget *clist;
   GtkWidget *date_dialog;
   GtkWidget *date_hbox;
   GtkWidget *date_vbox;
   GtkWidget *date_vbox2;
   GtkWidget *date_frame;


   char bufferp[255];

   if (numfileopened == 0) return;

   date_dialog = gtk_window_new(GTK_WINDOW_DIALOG);
   sprintf(bufferp,"%s","Insertion date");

   gtk_window_set_title(GTK_WINDOW(date_dialog), bufferp);
   gtk_widget_set_usize(date_dialog,400,400);

   date_frame = gtk_frame_new(" Choix du format ");
   gtk_container_border_width(GTK_CONTAINER(date_frame), 5);
   
   gtk_container_add(GTK_CONTAINER(date_dialog), date_frame);


   date_hbox = gtk_hbox_new(FALSE, 1);
   gtk_container_border_width(GTK_CONTAINER(date_hbox), 5);
   gtk_container_add(GTK_CONTAINER(date_dialog), date_frame);
   gtk_container_add(GTK_CONTAINER(print_frame), print_vbox);
   gtk_widget_show(print_vbox);
   gtk_widget_show(print_frame);

   insert_space(print_vbox);
   insert_space(print_vbox);
   insert_lbl(print_vbox,"Insrer votre commande d'impression :");
   insert_lbl(print_vbox," '%s' reprsente le nom du fichier   ");
   insert_space(print_vbox);
   print_entry = gtk_entry_new_with_max_length(255);
   gtk_entry_set_text(GTK_ENTRY(print_entry),"lpr %s");
   gtk_box_pack_start(GTK_BOX(print_vbox), print_entry, FALSE, FALSE, 5);
   gtk_widget_show(print_entry);

   insert_space(print_vbox);
   print_hbox = gtk_hbox_new(FALSE,1);
   gtk_box_pack_start(GTK_BOX(print_vbox), print_hbox, FALSE, TRUE, 5);
   gtk_widget_show(print_hbox);

   buttonOk = gtk_button_new_with_label("Print");
   buttonCancel = gtk_button_new_with_label("Cancel");

   gtk_box_pack_start(GTK_BOX(print_hbox), buttonOk, TRUE, TRUE, 5);
   gtk_box_pack_start(GTK_BOX(print_hbox), buttonCancel, TRUE,TRUE, 5);
   gtk_widget_show(buttonCancel);
   gtk_widget_show(buttonOk);

   gtk_widget_show(dialog_window);

   gtk_signal_connect_object(GTK_OBJECT(buttonCancel), "clicked",   GTK_SIGNAL_FUNC(gtk_widget_destroy), GTK_OBJECT(dialog_window));

   gtk_signal_connect(GTK_OBJECT(dialog_window),"destroy", GTK_SIGNAL_FUNC(gtk_widget_destroy), GTK_OBJECT(dialog_window));

   gtk_signal_connect_object(GTK_OBJECT(buttonOk), "clicked",   GTK_SIGNAL_FUNC(print_file_exec), GTK_OBJECT(print_entry));
 */
}				/* fin de insert_date() */


void
insert_date_exec (GtkWidget * widget, gpointer data)
{
/*
   FILE *infile;
   gchar * buf;

   if (numfileopened == 0) return;

   buf = (char *) malloc(1024);

   voir notice de la fonction date 
   system("date >~/.wdtemp");

   if ((infile = fopen("/home/zillprog/.wdtemp","r")) == NULL) merror("Could not insert date");

   fscanf(infile,"%s",buf);

   gtk_text_insert(GTK_TEXT(sheet[curfile].text),fixed_font,NULL,NULL,moi,-1);
   free(buf);
   fclose(infile);
 */
}				/* fin de insert_date_exec(); */



void
new_window (void)
{
  system ("wdesign &");
}				/* fin de new_window(); */


void
terminal (void)
{
  system ("sh &");
}				/* fin de terminal(); */


void
merror (gchar * label)
{
  GtkWidget *mwind;
  GtkWidget *mbox;
  GtkWidget *mbutton;
  GtkWidget *separator;
  GtkWidget *image;
  GtkWidget *mhbox;
  GtkWidget *lbl;

  image = new_pixmap (14, window->window, &color);

  mwind = gtk_window_new (GTK_WINDOW_DIALOG);
  gtk_window_set_title (GTK_WINDOW (mwind), "Error !");
  mbox = gtk_vbox_new (FALSE, 1);
  gtk_container_border_width (GTK_CONTAINER (mbox), 5);
  gtk_container_add (GTK_CONTAINER (mwind), mbox);
  gtk_widget_show (mbox);


  mhbox = gtk_hbox_new (FALSE, 1);
  gtk_box_pack_start (GTK_BOX (mhbox), image, TRUE, TRUE, 0);
  gtk_widget_show (image);

  lbl = gtk_label_new (label);
  gtk_box_pack_start (GTK_BOX (mhbox), lbl, TRUE, TRUE, 0);
  gtk_widget_show (lbl);

  gtk_box_pack_start (GTK_BOX (mbox), mhbox, TRUE, TRUE, 0);
  gtk_widget_show (mhbox);

  separator = gtk_hseparator_new ();
  gtk_box_pack_start (GTK_BOX (mbox), separator, FALSE, TRUE, 5);
  gtk_widget_show (separator);


  mbutton = gtk_button_new_with_label ("Ok");
  gtk_box_pack_start (GTK_BOX (mbox), mbutton, TRUE, TRUE, 5);
  gtk_widget_show (mbutton);
  gtk_widget_show (mwind);

  gtk_signal_connect_object (GTK_OBJECT (mbutton), "clicked", GTK_SIGNAL_FUNC (gtk_widget_destroy), GTK_OBJECT (mwind));

  if ((GTK_IS_FILE_SELECTION (filew)) == 1)
    gtk_widget_destroy (filew);
}				/* fin de merror(); */


void
ask_for (gchar * label)
{
  GtkWidget *mwind;
  GtkWidget *mbox;
  GtkWidget *mbutton;
  GtkWidget *separator;
  GtkWidget *image;
  GtkWidget *mhbox;
  GtkWidget *lbl;

  image = new_pixmap (14, window->window, &color);

  mwind = gtk_window_new (GTK_WINDOW_DIALOG);
  gtk_window_set_title (GTK_WINDOW (mwind), "Question !");
  mbox = gtk_vbox_new (FALSE, 1);
  gtk_container_border_width (GTK_CONTAINER (mbox), 5);
  gtk_container_add (GTK_CONTAINER (mwind), mbox);
  gtk_widget_show (mbox);


  mhbox = gtk_hbox_new (FALSE, 1);
  gtk_box_pack_start (GTK_BOX (mhbox), image, TRUE, TRUE, 0);
  gtk_widget_show (image);

  lbl = gtk_label_new (label);
  gtk_box_pack_start (GTK_BOX (mhbox), lbl, TRUE, TRUE, 0);
  gtk_widget_show (lbl);

  gtk_box_pack_start (GTK_BOX (mbox), mhbox, TRUE, TRUE, 0);
  gtk_widget_show (mhbox);

  separator = gtk_hseparator_new ();
  gtk_box_pack_start (GTK_BOX (mbox), separator, FALSE, TRUE, 5);
  gtk_widget_show (separator);


  mbutton = gtk_button_new_with_label ("Ok");
  gtk_box_pack_start (GTK_BOX (mbox), mbutton, TRUE, TRUE, 5);
  gtk_widget_show (mbutton);
  gtk_widget_show (mwind);

  gtk_signal_connect_object (GTK_OBJECT (mbutton), "clicked", GTK_SIGNAL_FUNC (gtk_widget_destroy), GTK_OBJECT (mwind));

  if ((GTK_IS_FILE_SELECTION (filew)) == 1)
    gtk_widget_destroy (filew);

}				/* fin de ask_for(); */



void
netscape_view (void)
{
  char commandln[255];

  if (numfileopened == 0)
    return;
if (sheet[curfile].new == TRUE) {
 merror("Can't view in external browser non saved files !");
 return;
}
  sprintf (commandln, browser_command, sheet[curfile].chemin);
  system (commandln);
}				/* fin de netscape_view(); */

void
int_view (void)
{

  GtkWidget *html_doc;
  GtkWidget *windo;
  GtkWidget *Vboxero;
  char buffer[70];
  char *bufferp;

  if (numfileopened == 0)
    return;

  windo = gtk_window_new (GTK_WINDOW_DIALOG);
  gtk_widget_set_usize (GTK_WIDGET (windo), 640, 480);
  sprintf (buffer, "Internal preview - %s", sheet[curfile].chemin);
  gtk_window_set_title (GTK_WINDOW (windo), buffer);

  Vboxero = gtk_vbox_new (FALSE, 1);
  gtk_container_add (GTK_CONTAINER (windo), Vboxero);
  gtk_container_border_width (GTK_CONTAINER (Vboxero), 2);
  gtk_widget_show (Vboxero);

  html_doc = gtk_xmhtml_new ();

  gtk_xmhtml_set_font_charset (GTK_XMHTML (html_doc), "ISO8859-1");
  gtk_xmhtml_set_allow_images (GTK_XMHTML (html_doc), TRUE);
  gtk_xmhtml_set_allow_color_switching (GTK_XMHTML (html_doc), TRUE);
  gtk_xmhtml_set_anchor_buttons (GTK_XMHTML (html_doc), TRUE);
  gtk_xmhtml_set_topline (GTK_XMHTML (html_doc), 0);

  gtk_box_pack_start (GTK_BOX (Vboxero), html_doc, TRUE, TRUE, 5);
  gtk_widget_show (html_doc);

  gtk_xmhtml_freeze (GTK_XMHTML (html_doc));
  bufferp = gtk_editable_get_chars (GTK_EDITABLE (sheet[curfile].text), 0,
		      gtk_text_get_length (GTK_TEXT (sheet[curfile].text)));
  gtk_xmhtml_source (GTK_XMHTML (html_doc), bufferp);
  gtk_xmhtml_set_def_body_image_url (GTK_XMHTML (html_doc), sheet[curfile].chemin);
  gtk_xmhtml_thaw (GTK_XMHTML (html_doc));
  

    gtk_widget_show (windo);

}				/* fin de int_view() */


gint
button_press (GtkWidget * widget, GdkEvent * event)
{
  coord(sheet[curfile].text, NULL);
  if (event->type == GDK_BUTTON_PRESS)
    {
      GdkEventButton *bevent = (GdkEventButton *) event;

      if (bevent->button == 3)
	{
	  gtk_menu_popup (GTK_MENU (widget), NULL, NULL, NULL, NULL,
			  bevent->button, bevent->time);
	  return TRUE;
	}
    }
  return FALSE;
}				/* fin de button_press() */

gint
button_press_coord (GtkWidget * widget, GdkEvent * event)
{
  char bufferp[60];
  if (event->type == GDK_BUTTON_PRESS)
    {
      GdkEventButton *bevent = (GdkEventButton *) event;
      if (bevent->button == 1)
	{

/* I didn't found yet how to make this work ! */

	  file_modified ();
	  sprintf (bufferp, " Line : %d, Column : %d", (GTK_TEXT (widget)->cursor_pos_y) / 9, (GTK_TEXT (widget)->cursor_pos_x) / 9);
	  gtk_statusbar_push (GTK_STATUSBAR (coord_status_bar), context_id, bufferp);

	  return TRUE;
	}
    }
  return FALSE;
}				/* fin de button_press_coord() */

GtkWidget *
new_pixmap (int type, GdkWindow * window, GdkColor * background)
{
  GtkWidget *wpixmap;
  GdkBitmap *mask;

  switch (type)
    {
    case 0:
      pixm = gdk_pixmap_create_from_xpm_d (window, &mask, background, new_file_xpm);
      break;

    case 1:
      pixm = gdk_pixmap_create_from_xpm_d (window, &mask, background, exit_xpm);
      break;

    case 2:
      pixm = gdk_pixmap_create_from_xpm_d (window, &mask, background, save_file_xpm);
      break;

    case 3:
      pixm = gdk_pixmap_create_from_xpm_d (window, &mask, background, open_file_xpm);
      break;

    case 4:
      pixm = gdk_pixmap_create_from_xpm_d (window, &mask, background, help_xpm);
      break;

    case 5:
      pixm = gdk_pixmap_create_from_xpm_d (window, &mask, background, settings_xpm);
      break;

    case 6:
      pixm = gdk_pixmap_create_from_xpm_d (window, &mask, background, close_file_xpm);
      break;

    case 7:
      pixm = gdk_pixmap_create_from_xpm_d (window, &mask, background, project_list_xpm);
      break;

    case 8:
      pixm = gdk_pixmap_create_from_xpm_d (window, &mask, background, copy_clipboard_xpm);
      break;

    case 9:
      pixm = gdk_pixmap_create_from_xpm_d (window, &mask, background, cut_clipboard_xpm);
      break;

    case 10:
      pixm = gdk_pixmap_create_from_xpm_d (window, &mask, background, paste_clipboard_xpm);
      break;

    case 11:
      pixm = gdk_pixmap_create_from_xpm_d (window, &mask, background, int_viewer_xpm);
      break;

    case 12:
      pixm = gdk_pixmap_create_from_xpm_d (window, &mask, background, netscape_xpm);
      break;

    case 13:
      pixm = gdk_pixmap_create_from_xpm_d (window, &mask, background, question_xpm);
      break;

    case 14:
      pixm = gdk_pixmap_create_from_xpm_d (window, &mask, background, erreur_xpm);
      break;

    case 15:
      pixm = gdk_pixmap_create_from_xpm_d (window, &mask, background, new_project_xpm);
      break;

    case 16:
      pixm = gdk_pixmap_create_from_xpm_d (window, &mask, background, close_project_xpm);
      break;

    case 17:
      pixm = gdk_pixmap_create_from_xpm_d (window, &mask, background, open_project_xpm);
      break;

    case 18:
      pixm = gdk_pixmap_create_from_xpm_d (window, &mask, background, save_project_xpm);
      break;

    case 19:
      pixm = gdk_pixmap_create_from_xpm_d (window, &mask, background, print_file_xpm);
      break;

    case 20:
      pixm = gdk_pixmap_create_from_xpm_d (window, &mask, background, print_box_xpm);
      break;

    case 21:
      pixm = gdk_pixmap_create_from_xpm_d (window, &mask, background, mini_logo2_xpm);
      break;

    case 22:
      pixm = gdk_pixmap_create_from_xpm_d (window, &mask, background, html_bold_xpm);
      break;

    case 23:
      pixm = gdk_pixmap_create_from_xpm_d (window, &mask, background, html_italik_xpm);
      break;

    case 24:
      pixm = gdk_pixmap_create_from_xpm_d (window, &mask, background, html_underlign_xpm);
      break;

    case 25:
      pixm = gdk_pixmap_create_from_xpm_d (window, &mask, background, html_font_xpm);
      break;

    case 26:
      pixm = gdk_pixmap_create_from_xpm_d (window, &mask, background, html_right_xpm);
      break;

    case 27:
      pixm = gdk_pixmap_create_from_xpm_d (window, &mask, background, html_left_xpm);
      break;

    case 28:
      pixm = gdk_pixmap_create_from_xpm_d (window, &mask, background, html_center_xpm);
      break;

    case 29:
      pixm = gdk_pixmap_create_from_xpm_d (window, &mask, background, html_justified_xpm);
      break;

    case 30:
      pixm = gdk_pixmap_create_from_xpm_d (window, &mask, background, html_blockquote_xpm);
      break;

    case 31:
      pixm = gdk_pixmap_create_from_xpm_d (window, &mask, background, html_br_xpm);
      break;

    case 32:
      pixm = gdk_pixmap_create_from_xpm_d (window, &mask, background, html_paragraph_xpm);
      break;

    case 33:
      pixm = gdk_pixmap_create_from_xpm_d (window, &mask, background, html_comment_xpm);
      break;

    case 34:
      pixm = gdk_pixmap_create_from_xpm_d (window, &mask, background, html_heading_xpm);
      break;

    case 35:
      pixm = gdk_pixmap_create_from_xpm_d (window, &mask, background, html_pre_xpm);
      break;

    case 36:
      pixm = gdk_pixmap_create_from_xpm_d (window, &mask, background, add_afile_prj_xpm);
      break;

    case 37:
      pixm = gdk_pixmap_create_from_xpm_d (window, &mask, background, remove_afile_prj_xpm);
      break;

    case 38:
      pixm = gdk_pixmap_create_from_xpm_d (window, &mask, background, open_all_prjfiles_xpm);
      break;

    case 39:
      pixm = gdk_pixmap_create_from_xpm_d (window, &mask, background, close_all_prjfiles_xpm);
      break;

    case 40:
      pixm = gdk_pixmap_create_from_xpm_d (window, &mask, background, compact_tags_xpm);
      break;

    case 41:
      pixm = gdk_pixmap_create_from_xpm_d (window, &mask, background, repeat_lasttag_xpm);
      break;

    case 42:
      pixm = gdk_pixmap_create_from_xpm_d (window, &mask, background, html_bigtext_xpm);
      break;

    case 43:
      pixm = gdk_pixmap_create_from_xpm_d (window, &mask, background, html_smalltext_xpm);
      break;

    case 44:
      pixm = gdk_pixmap_create_from_xpm_d (window, &mask, background, html_text_blink_xpm);
      break;

    case 45:
      pixm = gdk_pixmap_create_from_xpm_d (window, &mask, background, html_text_cite_xpm);
      break;

    case 55:
      pixm = gdk_pixmap_create_from_xpm_d (window, &mask, background, html_html_xpm);
      break;

    case 56:
      pixm = gdk_pixmap_create_from_xpm_d (window, &mask, background, html_head_xpm);
      break;

    case 57:
      pixm = gdk_pixmap_create_from_xpm_d (window, &mask, background, html_title_xpm);
      break;

    case 58:
      pixm = gdk_pixmap_create_from_xpm_d (window, &mask, background, html_meta_xpm);
      break;

    case 59:
      pixm = gdk_pixmap_create_from_xpm_d (window, &mask, background, html_banner_xpm);
      break;

    case 60:
      pixm = gdk_pixmap_create_from_xpm_d (window, &mask, background, html_body_xpm);
      break;


    case 61:
      pixm = gdk_pixmap_create_from_xpm_d (window, &mask, background, html_doctype_xpm);
      break;


    case 62:
      pixm = gdk_pixmap_create_from_xpm_d (window, &mask, background, html_text_em_xpm);
      break;

    case 63:
      pixm = gdk_pixmap_create_from_xpm_d (window, &mask, background, html_text_striked_xpm);
      break;

    case 64:
      pixm = gdk_pixmap_create_from_xpm_d (window, &mask, background, html_text_sup_xpm);
      break;

    case 65:
      pixm = gdk_pixmap_create_from_xpm_d (window, &mask, background, html_text_sub_xpm);
      break;

    case 66:
      pixm = gdk_pixmap_create_from_xpm_d (window, &mask, background, html_text_tt_xpm);
      break;

    case 67:
      pixm = gdk_pixmap_create_from_xpm_d (window, &mask, background, html_text_kbd_xpm);
      break;

    case 68:
      pixm = gdk_pixmap_create_from_xpm_d (window, &mask, background, html_text_listing_xpm);
      break;

    case 69:
      pixm = gdk_pixmap_create_from_xpm_d (window, &mask, background, tag_help_window_xpm);
      break;


    case 70:
      pixm = gdk_pixmap_create_from_xpm_d (window, &mask, background, html_text_code_xpm);
      break;

    case 71:
      pixm = gdk_pixmap_create_from_xpm_d (window, &mask, background, html_form_input_password_xpm);
      break;

    case 72:
      pixm = gdk_pixmap_create_from_xpm_d (window, &mask, background, html_form_input_text_xpm);
      break;


    case 73:
      pixm = gdk_pixmap_create_from_xpm_d (window, &mask, background, html_form_reset_xpm);
      break;

    case 74:
      pixm = gdk_pixmap_create_from_xpm_d (window, &mask, background, html_form_submit_xpm);
      break;

    case 75:
      pixm = gdk_pixmap_create_from_xpm_d (window, &mask, background, html_hr_xpm);
      break;


    case 76:
      pixm = gdk_pixmap_create_from_xpm_d (window, &mask, background, html_form_checkbox_xpm);
      break;

    case 77:
      pixm = gdk_pixmap_create_from_xpm_d (window, &mask, background, html_form_radio_xpm);
      break;

    case 78:
      pixm = gdk_pixmap_create_from_xpm_d (window, &mask, background, html_form_textarea_xpm);
      break;

    case 79:
      pixm = gdk_pixmap_create_from_xpm_d (window, &mask, background, html_form_form_xpm);
      break;

    case 80:
      pixm = gdk_pixmap_create_from_xpm_d (window, &mask, background, html_form_hidden_xpm);
      break;

    case 81:
      pixm = gdk_pixmap_create_from_xpm_d (window, &mask, background, html_list_ordered_xpm);
      break;

    case 82:
      pixm = gdk_pixmap_create_from_xpm_d (window, &mask, background, html_list_unordered_xpm);
      break;

    case 83:
      pixm = gdk_pixmap_create_from_xpm_d (window, &mask, background, html_list_listitem_xpm);
      break;

    case 84:
      pixm = gdk_pixmap_create_from_xpm_d (window, &mask, background, html_form_button_xpm);
      break;

    case 85:
      pixm = gdk_pixmap_create_from_xpm_d (window, &mask, background, html_list_dd_xpm);
      break;

    case 86:
      pixm = gdk_pixmap_create_from_xpm_d (window, &mask, background, html_list_dl_xpm);
      break;

    case 87:
      pixm = gdk_pixmap_create_from_xpm_d (window, &mask, background, html_list_dt_xpm);
      break;

    case 88:
      pixm = gdk_pixmap_create_from_xpm_d (window, &mask, background, html_common_anchor_xpm);
      break;

    case 89:
      pixm = gdk_pixmap_create_from_xpm_d (window, &mask, background, html_common_img_xpm);
      break;

    case 90:
      pixm = gdk_pixmap_create_from_xpm_d (window, &mask, background, html_page_internal_anchor_xpm);
      break;

    case 91:
      pixm = gdk_pixmap_create_from_xpm_d (window, &mask, background, html_page_internal_link_xpm);
      break;

    case 92:
      pixm = gdk_pixmap_create_from_xpm_d (window, &mask, background, html_page_linktop_xpm);
      break;

    case 93:
      pixm = gdk_pixmap_create_from_xpm_d (window, &mask, background, html_table_table_xpm);
      break; 

    case 94:
      pixm = gdk_pixmap_create_from_xpm_d (window, &mask, background, html_table_head_xpm);
      break; 

    case 95:
      pixm = gdk_pixmap_create_from_xpm_d (window, &mask, background, html_table_data_xpm);
      break;

    case 96:
      pixm = gdk_pixmap_create_from_xpm_d (window, &mask, background, html_table_row_xpm);
      break;

    case 97:
      pixm = gdk_pixmap_create_from_xpm_d (window, &mask, background, html_table_caption_xpm);
      break;

    case 98:
      pixm = gdk_pixmap_create_from_xpm_d (window, &mask, background, html_form_fieldset_xpm);
      break;

    case 99:
      pixm = gdk_pixmap_create_from_xpm_d (window, &mask, background, html_list_dir2_xpm);
      break;

    case 100:
      pixm = gdk_pixmap_create_from_xpm_d (window, &mask, background, html_list_menu_xpm);
      break;

    case 101:
      pixm = gdk_pixmap_create_from_xpm_d (window, &mask, background, insert_hex_color_xpm);
      break;

    case 102:
      pixm = gdk_pixmap_create_from_xpm_d (window, &mask, background, html_font_minus_xpm);
      break;

    case 103:
      pixm = gdk_pixmap_create_from_xpm_d (window, &mask, background, html_font_plus_xpm);
      break;

    case 104:
      pixm = gdk_pixmap_create_from_xpm_d (window, &mask, background, html_font_basefont_xpm);
      break;


    }

  wpixmap = gtk_pixmap_new (pixm, mask);
  return wpixmap;
}				/* fin de new_pixmap() */



void
insert_space (GtkWidget * wid)
{

  GtkWidget *lbl1;

  lbl1 = gtk_label_new ("");
  gtk_box_pack_start (GTK_BOX (wid), lbl1, FALSE, FALSE, 0);
  gtk_widget_show (lbl1);
}



void
insert_lbl (GtkWidget * wid, gchar * labe)
{

  GtkWidget *lbl1;

  lbl1 = gtk_label_new (labe);
  gtk_box_pack_start (GTK_BOX (wid), lbl1, FALSE, FALSE, 0);
  gtk_widget_show (lbl1);
}				/* fin de insert_lbl */



/* extracts the filename  */
char *
getname (char *path)
{
  int i;
  char *buffer;
  i = strlen (path) - 1;
  if (i > -1)
    while (path[i] != '/' && i > 0)
      i--;
  buffer = (char *) malloc (strlen (path) - i);
  i++;
  strncpy (buffer, &path[i], strlen (path) - i);
  buffer[strlen (path) - i] = '\0';
  return buffer;
}				/* fin de getname() */


/* get the file extension */
char *
getext (char *path)
{
  int i;
  char *buffer;
  i = strlen (path) - 1;
  if (i > -1)
    while (path[i] != '.' && i > 0)
      i--;
  buffer = (char *) malloc (strlen (path) - i);
  i++;
  strncpy (buffer, &path[i], strlen (path) - i);
  buffer[strlen (path) - i] = '\0';
  return buffer;
}				/* fin de getext() */


void
updatefilelist (short num)
{
  short i;
  for (i = numfileopened; i > num; i--)
    {
      sheet[i] = sheet[i - 1];
    }
}


void
close_application (GtkWidget * widget, gpointer data)
{
  gtk_main_quit ();
}

void
about (void)
{
  GtkWidget *hbutton;
  GtkWidget *wind;
  GtkWidget *Vboxer;
  GtkWidget *frame;
  GtkWidget *img;
  gchar ver[50];

  wind = gtk_window_new (GTK_WINDOW_DIALOG);
  gtk_window_set_title (GTK_WINDOW (wind), "About");

  frame = gtk_frame_new (" Copyright - License ");
  gtk_container_border_width (GTK_CONTAINER (frame), 5);

  Vboxer = gtk_vbox_new (FALSE, 1);
  gtk_container_border_width (GTK_CONTAINER (Vboxer), 2);
  gtk_container_add (GTK_CONTAINER (wind), frame);
  gtk_container_add (GTK_CONTAINER (frame), Vboxer);
  gtk_widget_show (Vboxer);

  insert_space (Vboxer);
  img = new_pixmap (21, window->window, &color);
  gtk_box_pack_start (GTK_BOX (Vboxer), img, FALSE, FALSE, 0);
  gtk_widget_show (img);

  insert_space (Vboxer);
  sprintf (ver, "Web Designer %s", VERSION);
  insert_lbl (Vboxer, ver);
  insert_lbl (Vboxer, "http://webdesigner.linuxave.net");

  insert_space (Vboxer);
  insert_lbl (Vboxer, "Copyright (C) 1999-2000 LADISLAS Willhem");
  insert_lbl (Vboxer, "zillprog@freesurf.fr");
  insert_space (Vboxer);
  insert_lbl (Vboxer, "License : GPL (see file COPYING)");

  insert_space (Vboxer);

  hbutton = gtk_button_new_with_label ("Oh Yeah !!!");
  gtk_box_pack_start (GTK_BOX (Vboxer), hbutton, TRUE, FALSE, 5);
  gtk_widget_show (hbutton);

  gtk_signal_connect_object (GTK_OBJECT (hbutton), "clicked", GTK_SIGNAL_FUNC (gtk_widget_destroy), GTK_OBJECT (wind));

  gtk_signal_connect (GTK_OBJECT (wind), "destroy", GTK_SIGNAL_FUNC (gtk_widget_destroy), GTK_OBJECT (wind));

  gtk_widget_set_usize (GTK_WIDGET (frame), 400, 280);
  gtk_widget_show (frame);
  gtk_widget_show (wind);
}				/* fin de about() */
