/*  Web Designer
   Copyright (C) 1999  LADISLAS Willhem

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

   Author's email : zillprog@freesurf.fr

   snailmail :      LADISLAS Willhem
   2, rue du Serpolet
   95490 VAUREAL
   FRANCE
 */

#include "webdesigner.h"

/*
   This files contains all the functions concerning the "page" related html tags :
   void load_meta_info(void)

 */

GtkWidget *meta_info_entry1;
GtkWidget *meta_info_entry2;
GtkWidget *meta_info_entry3;
GtkWidget *meta_info_entry4;
gint doclist_row;


void 
doctype_selection_made (GtkWidget * clist, gint row, gint column, GdkEventButton * event, gpointer data)
{

  int i, j, x = 0;
  gchar *text;

  text = malloc (400);
  switch (doclist_row)
    {
    case 1:
      text = g_strdup_printf ("%s", "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.0//EN\">");
      break;
    case 2:
      text = g_strdup_printf ("%s", "<!DOCTYPE HTML PUBLIC \"-//IETF//DTD HTML//EN\">");
      break;
    case 3:
      text = g_strdup_printf ("%s", "<!DOCTYPE HTML PUBLIC \"-//IETF//DTD HTML 1.0//EN\">");
      break;
    case 4:
      text = g_strdup_printf ("%s", "<!DOCTYPE HTML PUBLIC \"-//IETF//DTD HTML 2.0//EN\">");
      break;
    case 5:
      text = g_strdup_printf ("%s", "<!DOCTYPE HTML PUBLIC \"-//IETF//DTD HTML 3.2//EN\">");
      break;
    case 6:
      text = g_strdup_printf ("%s", "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 3.2 Draft//EN\">");
      break;
    case 7:
      text = g_strdup_printf ("%s", "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 3.2 Final//EN\">");
      break;
    case 8:
      text = g_strdup_printf ("%s", "<!DOCTYPE HTML PUBLIC \"-//IETF//DTD HTML Level 0//EN\">");
      break;
    case 9:
      text = g_strdup_printf ("%s", "<!DOCTYPE HTML PUBLIC \"-//IETF//DTD HTML Level 1//EN\">");
      break;
    case 10:
      text = g_strdup_printf ("%s", "<!DOCTYPE HTML PUBLIC \"-//IETF//DTD HTML Level 2//EN\">");
      break;
    case 11:
      text = g_strdup_printf ("%s", "<!DOCTYPE HTML PUBLIC \"-//IETF//DTD HTML Level 3//EN\">");
      break;
    case 12:
      text = g_strdup_printf ("%s", "<!DOCTYPE HTML PUBLIC \"-//Microsoft/DTD Internet Expolorer 3.01 HTML//EN\">");
      break;
    case 13:
      text = g_strdup_printf ("%s", "<!DOCTYPE HTML PUBLIC \"-//Netscape Comm. Corp.//DTD HTML//EN\">");
      break;
    case 14:
      text = g_strdup_printf ("%s", "<!DOCTYPE HTML PUBLIC \"-//Sun Microsystems Corp.//DTD Hotjava HTML//EN\">");
      break;
    }

  if (numfileopened == 0)
    return;

  j = strlen (text);
  for (i = 0; i < strlen (text); i++)
    {
      if (text[j - i] == '<')
	x = i;
    }

  gtk_text_set_point (GTK_TEXT (sheet[curfile].text), gtk_editable_get_position (GTK_EDITABLE (sheet[curfile].text)));

  gtk_text_insert (GTK_TEXT (sheet[curfile].text), fixed_font, &blue, NULL, text, strlen (text));

  i = gtk_text_get_point (GTK_TEXT (sheet[curfile].text));
  gtk_editable_set_position (GTK_EDITABLE (sheet[curfile].text), i - x);

  if (sheet[curfile].saved == TRUE)
    sheet[curfile].saved = FALSE;

  free (text);
}				/* fin de doctype_selection_made() */

void
doclist_selection_made (GtkWidget * clist, gint row, gint column, GdkEventButton * event, gpointer data)
{
  doclist_row = row + 1;
  printf ("%d", row + 1);
}				/* fin de doclist_selection_made() */


void
init_doctypelist (void)
{

  gchar *style[1] =
  {"<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.0//EN\">"};
  gchar *style2[1] =
  {"<!DOCTYPE HTML PUBLIC \"-//IETF//DTD HTML//EN\">"};
  gchar *style3[1] =
  {"<!DOCTYPE HTML PUBLIC \"-//IETF//DTD HTML 1.0//EN\">"};
  gchar *style4[1] =
  {"<!DOCTYPE HTML PUBLIC \"-//IETF//DTD HTML 2.0//EN\">"};
  gchar *style5[1] =
  {"<!DOCTYPE HTML PUBLIC \"-//IETF//DTD HTML 3.2//EN\">"};
  gchar *style6[1] =
  {"<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 3.2 Draft//EN\">"};
  gchar *style7[1] =
  {"<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 3.2 Final//EN\">"};
  gchar *style8[1] =
  {"<!DOCTYPE HTML PUBLIC \"-//IETF//DTD HTML Level 0//EN\">"};
  gchar *style9[1] =
  {"<!DOCTYPE HTML PUBLIC \"-//IETF//DTD HTML Level 1//EN\">"};
  gchar *style10[1] =
  {"<!DOCTYPE HTML PUBLIC \"-//IETF//DTD HTML Level 2//EN\">"};
  gchar *style11[1] =
  {"<!DOCTYPE HTML PUBLIC \"-//IETF//DTD HTML Level 3//EN\">"};
  gchar *style12[1] =
  {"<!DOCTYPE HTML PUBLIC \"-//Microsoft/DTD Internet Expolorer 3.01 HTML//EN\">"};
  gchar *style13[1] =
  {"<!DOCTYPE HTML PUBLIC \"-//Netscape Comm. Corp.//DTD HTML//EN\">"};
  gchar *style14[1] =
  {"<!DOCTYPE HTML PUBLIC \"-//Sun Microsystems Corp.//DTD Hotjava HTML//EN\">"};

  GtkWidget *doctypewindow;
  GtkWidget *doctypeclist;
  GtkWidget *doctypevbox;
  GtkWidget *doctypetable;
  GtkWidget *doctypebutton;


  doctypewindow = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_widget_set_usize (GTK_WIDGET (doctypewindow), 560, 270);
  gtk_window_set_title (GTK_WINDOW (doctypewindow), "Document type");

  doctypevbox = gtk_vbox_new (FALSE, 5);
  gtk_container_set_border_width (GTK_CONTAINER (doctypevbox), 5);
  gtk_container_add (GTK_CONTAINER (doctypewindow), doctypevbox);

  doctypetable = gtk_table_new (2, 2, FALSE);
  doctypeclist = gtk_clist_new (1);
  gtk_clist_set_column_width (GTK_CLIST (doctypeclist), 0, 350);
  gtk_clist_set_shadow_type (GTK_CLIST (doctypeclist), GTK_SHADOW_IN);
  gtk_widget_show (doctypeclist);

  gtk_clist_append (GTK_CLIST (doctypeclist), style);
  gtk_clist_append (GTK_CLIST (doctypeclist), style2);
  gtk_clist_append (GTK_CLIST (doctypeclist), style3);
  gtk_clist_append (GTK_CLIST (doctypeclist), style4);
  gtk_clist_append (GTK_CLIST (doctypeclist), style5);
  gtk_clist_append (GTK_CLIST (doctypeclist), style6);
  gtk_clist_append (GTK_CLIST (doctypeclist), style7);
  gtk_clist_append (GTK_CLIST (doctypeclist), style8);
  gtk_clist_append (GTK_CLIST (doctypeclist), style9);
  gtk_clist_append (GTK_CLIST (doctypeclist), style10);
  gtk_clist_append (GTK_CLIST (doctypeclist), style11);
  gtk_clist_append (GTK_CLIST (doctypeclist), style12);
  gtk_clist_append (GTK_CLIST (doctypeclist), style13);
  gtk_clist_append (GTK_CLIST (doctypeclist), style14);

  gtk_table_attach (GTK_TABLE (doctypetable), doctypeclist, 0, 2, 0, 1, GTK_FILL | GTK_EXPAND, GTK_FILL, 3, 6);

  gtk_signal_connect (GTK_OBJECT (doctypeclist), "select_row",
		      GTK_SIGNAL_FUNC (doclist_selection_made), NULL);

  doctypebutton = gtk_button_new_with_label ("       OK       ");
  gtk_table_attach (GTK_TABLE (doctypetable), doctypebutton, 0, 1, 1, 2, GTK_SHRINK, GTK_SHRINK, 3, 6);
  gtk_widget_show (doctypebutton);

  gtk_signal_connect (GTK_OBJECT (doctypebutton), "clicked",
		      GTK_SIGNAL_FUNC (doctype_selection_made), NULL);

  gtk_signal_connect_object (GTK_OBJECT (doctypebutton), "clicked",
	  GTK_SIGNAL_FUNC (gtk_widget_destroy), GTK_OBJECT (doctypewindow));

  doctypebutton = gtk_button_new_with_label ("     Cancel    ");
  gtk_table_attach (GTK_TABLE (doctypetable), doctypebutton, 1, 2, 1, 2, GTK_SHRINK, GTK_SHRINK, 3, 6);
  gtk_widget_show (doctypebutton);

  gtk_signal_connect_object (GTK_OBJECT (doctypebutton), "clicked",
	  GTK_SIGNAL_FUNC (gtk_widget_destroy), GTK_OBJECT (doctypewindow));

  gtk_box_pack_start (GTK_BOX (doctypevbox), doctypetable, TRUE, TRUE, 0);

  gtk_widget_show (doctypetable);
  gtk_widget_show (doctypevbox);
  gtk_widget_show (doctypewindow);
}

void
meta_info_copy (GtkWidget * widget, gpointer data)
{

  gchar *text;

  text = gtk_entry_get_text (GTK_ENTRY (meta_info_entry1));


  gtk_text_set_point (GTK_TEXT (sheet[curfile].text), 0);
  gtk_editable_set_position (GTK_EDITABLE (sheet[curfile].text), 0);

  gtk_text_insert (GTK_TEXT (sheet[curfile].text), fixed_font, &blue, NULL, "<TITLE>", -1);
  gtk_text_insert (GTK_TEXT (sheet[curfile].text), fixed_font, &black, NULL, text, strlen (text));
  gtk_text_insert (GTK_TEXT (sheet[curfile].text), fixed_font, &blue, NULL, "</TITLE>\n", -1);


  text = gtk_entry_get_text (GTK_ENTRY (meta_info_entry4));
  gtk_text_insert (GTK_TEXT (sheet[curfile].text), fixed_font, &blue, NULL, "<META NAME=", -1);
  gtk_text_insert (GTK_TEXT (sheet[curfile].text), fixed_font, &green, NULL, "\"Author\"", -1);
  gtk_text_insert (GTK_TEXT (sheet[curfile].text), fixed_font, &blue, NULL, " CONTENT=", -1);
  gtk_text_insert (GTK_TEXT (sheet[curfile].text), fixed_font, &green, NULL, "\"", -1);
  gtk_text_insert (GTK_TEXT (sheet[curfile].text), fixed_font, &green, NULL, text, strlen (text));
  gtk_text_insert (GTK_TEXT (sheet[curfile].text), fixed_font, &green, NULL, "\"", -1);
  gtk_text_insert (GTK_TEXT (sheet[curfile].text), fixed_font, &blue, NULL, ">\n", -1);


  text = gtk_entry_get_text (GTK_ENTRY (meta_info_entry2));
  gtk_text_insert (GTK_TEXT (sheet[curfile].text), fixed_font, &blue, NULL, "<META NAME=", -1);
  gtk_text_insert (GTK_TEXT (sheet[curfile].text), fixed_font, &green, NULL, "\"Description\"", -1);
  gtk_text_insert (GTK_TEXT (sheet[curfile].text), fixed_font, &blue, NULL, " CONTENT=", -1);
  gtk_text_insert (GTK_TEXT (sheet[curfile].text), fixed_font, &green, NULL, "\"", -1);
  gtk_text_insert (GTK_TEXT (sheet[curfile].text), fixed_font, &green, NULL, text, strlen (text));
  gtk_text_insert (GTK_TEXT (sheet[curfile].text), fixed_font, &green, NULL, "\"", -1);
  gtk_text_insert (GTK_TEXT (sheet[curfile].text), fixed_font, &blue, NULL, ">\n", -1);


  text = gtk_entry_get_text (GTK_ENTRY (meta_info_entry3));
  gtk_text_insert (GTK_TEXT (sheet[curfile].text), fixed_font, &blue, NULL, "<META NAME=", -1);
  gtk_text_insert (GTK_TEXT (sheet[curfile].text), fixed_font, &green, NULL, "\"Keywords\"", -1);
  gtk_text_insert (GTK_TEXT (sheet[curfile].text), fixed_font, &blue, NULL, " CONTENT=", -1);
  gtk_text_insert (GTK_TEXT (sheet[curfile].text), fixed_font, &green, NULL, "\"", -1);
  gtk_text_insert (GTK_TEXT (sheet[curfile].text), fixed_font, &green, NULL, text, strlen (text));
  gtk_text_insert (GTK_TEXT (sheet[curfile].text), fixed_font, &green, NULL, "\"", -1);
  gtk_text_insert (GTK_TEXT (sheet[curfile].text), fixed_font, &blue, NULL, ">\n", -1);

  gtk_widget_destroy (GTK_WIDGET (widget));
}				/* fin de meta_info_copy */

void
insert_doctype (void)
{

}				/* fin de insert_doctype */

void
load_meta_info (void)
{
  GtkWidget *okbutton;
  GtkWidget *meta_info_window;
  GtkWidget *meta_info_vbox;
  GtkWidget *meta_info_table;
  GtkWidget *meta_info_lbl;

  if (numfileopened == 0)
    return;

  meta_info_window = gtk_window_new (GTK_WINDOW_DIALOG);
  gtk_window_set_title (GTK_WINDOW (meta_info_window), "Meta informations");
  gtk_widget_set_usize (GTK_WIDGET (meta_info_window), 500, 160);

  meta_info_vbox = gtk_vbox_new (FALSE, 1);
  gtk_container_border_width (GTK_CONTAINER (meta_info_vbox), 2);
  gtk_widget_show (meta_info_vbox);
  gtk_container_add (GTK_CONTAINER (meta_info_window), meta_info_vbox);

  meta_info_table = gtk_table_new (4, 3, FALSE);
  gtk_box_pack_start (GTK_BOX (meta_info_vbox), meta_info_table, TRUE, FALSE, 5);
  gtk_widget_show (meta_info_table);


  meta_info_lbl = gtk_label_new ("      Title :");
  gtk_table_attach (GTK_TABLE (meta_info_table), meta_info_lbl, 0, 1, 0, 1, GTK_FILL, GTK_FILL, 2, 2);
  gtk_widget_show (meta_info_lbl);

  meta_info_lbl = gtk_label_new ("Description :");
  gtk_table_attach (GTK_TABLE (meta_info_table), meta_info_lbl, 0, 1, 1, 2, GTK_FILL, GTK_FILL, 6, 6);
  gtk_widget_show (meta_info_lbl);

  meta_info_lbl = gtk_label_new ("  Keywords :");
  gtk_table_attach (GTK_TABLE (meta_info_table), meta_info_lbl, 0, 1, 2, 3, GTK_FILL, GTK_FILL, 2, 2);
  gtk_widget_show (meta_info_lbl);

  meta_info_lbl = gtk_label_new ("     Author :");
  gtk_table_attach (GTK_TABLE (meta_info_table), meta_info_lbl, 0, 1, 3, 4, GTK_FILL, GTK_FILL, 2, 2);
  gtk_widget_show (meta_info_lbl);


  meta_info_entry1 = gtk_entry_new ();
  gtk_table_attach (GTK_TABLE (meta_info_table), meta_info_entry1, 1, 2, 0, 1, GTK_FILL, GTK_FILL, 4, 4);
  gtk_widget_show (meta_info_entry1);

  meta_info_entry2 = gtk_entry_new ();
  gtk_table_attach (GTK_TABLE (meta_info_table), meta_info_entry2, 1, 2, 1, 2, GTK_FILL, GTK_FILL, 4, 4);
  gtk_widget_show (meta_info_entry2);

  meta_info_entry3 = gtk_entry_new ();
  gtk_table_attach (GTK_TABLE (meta_info_table), meta_info_entry3, 1, 2, 2, 3, GTK_FILL | GTK_EXPAND, GTK_FILL, 4, 4);
  gtk_widget_show (meta_info_entry3);

  meta_info_entry4 = gtk_entry_new ();
  gtk_table_attach (GTK_TABLE (meta_info_table), meta_info_entry4, 1, 2, 3, 4, GTK_FILL, GTK_FILL, 4, 4);
  gtk_widget_show (meta_info_entry4);

  okbutton = gtk_button_new_with_label ("OK");
  gtk_table_attach (GTK_TABLE (meta_info_table), okbutton, 2, 3, 0, 1, GTK_FILL, GTK_FILL, 4, 4);
  gtk_widget_show (okbutton);

  gtk_signal_connect_object (GTK_OBJECT (okbutton), "clicked", GTK_SIGNAL_FUNC (meta_info_copy), GTK_OBJECT (meta_info_window));

  okbutton = gtk_button_new_with_label ("     Cancel     ");
  gtk_table_attach (GTK_TABLE (meta_info_table), okbutton, 2, 3, 1, 2, GTK_FILL, GTK_FILL, 4, 4);
  gtk_widget_show (okbutton);

  gtk_signal_connect_object (GTK_OBJECT (okbutton), "clicked", GTK_SIGNAL_FUNC (gtk_widget_destroy), GTK_OBJECT (meta_info_window));


  gtk_widget_show (meta_info_window);

}				/* fin load_meta_info */
