/*  Web Designer
   Copyright (C) 1999  LADISLAS Willhem

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

   Author's email : zillprog@freesurf.fr

   snailmail : 
   LADISLAS Willhem
   2, rue du Serpolet
   95490 VAUREAL
   FRANCE
 */
#include "webdesigner.h"
#include "mainheader.h"


static GtkItemFactoryEntry menu_items[] =
{
  {N_("/_File"), NULL, NULL, 0, "<Branch>"},
  {"/_File/t1", NULL, NULL, 0, "<Tearoff>"},
  {"/File/_New", "<control>N", newfile, 2, NULL},
  {"/File/_Open...", "<control>O", openfile, 0, NULL},
  {"/File/Close", "<control>W", close_primary, 0, NULL},
  {"/File/_Close all", NULL, close_all_files, 0, NULL},
  {"/File/sep1", NULL, NULL, 0, "<Separator>"},
  {"/File/_Save", "<control>S", savefile, 0, NULL},
  {"/File/Save as...", NULL, dialogsaveas, 0, NULL},
  {"/File/sep2", NULL, NULL, 0, "<Separator>"},
  {"/File/Import...", NULL, import_file_dialog, 0, NULL},
  {"/File/Information...", NULL, display_file_info, 0, NULL},
  {"/File/_Print...", NULL, print_file, 0, NULL},
  {"/File/sep3", NULL, NULL, 0, "<Separator>"},
  {"/File/_Quit", "<control>Q", gtk_main_quit, 0, NULL},

  {"/_Edit", NULL, NULL, 0, "<Branch>"},
  {"/_Edit/t1", NULL, NULL, 0, "<Tearoff>"},
  {"/Edit/Cut", "<control>X", clipboard_actions, 0, NULL},
  {"/Edit/_Copy", "<control>C", clipboard_actions, 1, NULL},
  {"/Edit/Paste", "<control>V", clipboard_actions, 2, NULL},
  {"/Edit/se4", NULL, NULL, 0, "<Separator>"},
  {"/Edit/Paste in new doc", NULL, clipboard_actions, 5, NULL},
  {"/Edit/Compact HTML tags", NULL, compact_file, 0, NULL},
  {"/Edit/Replace special chars", NULL, compact_file, 1, NULL},
  {"/Edit/Remove all tags", NULL, remove_tags, 0, NULL},
  {"/Edit/sep4", NULL, NULL, 0, "<Separator>"},
  {"/Edit/Select _All", "<alt>A", clipboard_actions, 3, NULL},
  {"/Edit/Erase selection", NULL, clipboard_actions, 4, NULL},
  {"/Edit/Repeat tag", "<control>R", repeat_tag, 0, NULL},
  {"/Edit/sep5", NULL, NULL, 0, "<Separator>"},
  {"/Edit/Go to line...", "<control>L", go_line, 0, NULL},
/*  {"/Edit/Insert date", NULL, insert_date, 0, NULL}, */

  {"/_Project", NULL, NULL, 0, "<Branch>"},
  {"/_Project/t1", NULL, NULL, 0, "<Tearoff>"},
  {"/Project/New", NULL, new_project, 0, NULL},
  {"/Project/Open...", NULL, open_project_dialog, 0, NULL},
  {"/Project/Close", NULL, close_project, 0, NULL},
  {"/Project/sep6", NULL, NULL, 0, "<Separator>"},
  {"/Project/Save", NULL, save_project, 0, NULL},
  {"/Project/Save as...", NULL, save_project, 1, NULL},
  {"/Project/sep7", NULL, NULL, 0, "<Separator>"},
  {"/Project/Project manager", NULL, init_clist, 0, NULL},
  {"/Project/Open all project files", NULL, open_all_prjfiles, 0, NULL},
  {"/Project/Close all project files", NULL, close_all_prjfiles, 0, NULL},
  {"/Project/se7", NULL, NULL, 0, "<Separator>"},
  {"/Project/Add a file...", NULL, add_afile_prj_dialog, 0, NULL},
  {"/Project/Add current file", NULL, add_file, 0, NULL},
  {"/Project/Remove current file", NULL, remove_file, 0, NULL},

  {"/_Tags", NULL, NULL, 0, "<Branch>"},
  {"/_Tags/t1", NULL, NULL, 0, "<Tearoff>"},
  {"/Tags/Common", NULL, NULL, 0, "<Branch>"},
  {"/Tags/Common/t1", NULL, NULL, 0, "<Tearoff>"},
  {"/Tags/Common/Font", NULL, tag_insert_exec, 0, ""},
  {"/Tags/Common/sep9", NULL, NULL, 0, "<Separator>"},
  {"/Tags/Common/Heading", NULL, NULL, 0, "<Branch>"},
  {"/Tags/Common/Heading/t1", NULL, NULL, 0, "<Tearoff>"},
  {"/Tags/Common/Heading/H1", NULL, tag_insert_exec, 49, ""},
  {"/Tags/Common/Heading/H2", NULL, tag_insert_exec, 50, ""},
  {"/Tags/Common/Heading/H3", NULL, tag_insert_exec, 51, ""},
  {"/Tags/Common/Heading/H4", NULL, tag_insert_exec, 52, ""},
  {"/Tags/Common/Heading/H5", NULL, tag_insert_exec, 53, ""},
  {"/Tags/Common/Heading/H6", NULL, tag_insert_exec, 54, ""},
  {"/Tags/Common/Text", NULL, NULL, 0, "<Branch>"},
  {"/Tags/Common/Text/t1", NULL, NULL, 0, "<Tearoff>"},
  {"/Tags/Common/Text/Bold", "<control>G", tag_insert_exec, 1, ""},
  {"/Tags/Common/Text/Italic", "<control>I", tag_insert_exec, 2, ""},
  {"/Tags/Common/Text/Underlign", "<alt>U", tag_insert_exec, 3, ""},
  {"/Tags/Common/Text/Center", "<control>M", tag_insert_exec, 11, ""},
  {"/Tags/Common/Text/Preformatted", NULL, tag_insert_exec, 8, ""},

  {"/Tags/Common/Paragraph", NULL, NULL, 0, "<Branch>"},
  {"/Tags/Common/Paragraph/t1", NULL, NULL, 0, "<Tearoff>"},
  {"/Tags/Common/Paragraph/Left", NULL, tag_insert_exec, 4, ""},
  {"/Tags/Common/Paragraph/Center", NULL, tag_insert_exec, 5, ""},
  {"/Tags/Common/Paragraph/Right", NULL, tag_insert_exec, 6, ""},
  {"/Tags/Common/Paragraph/justify", NULL, tag_insert_exec, 7, ""},
  {"/Tags/Common/Anchor", NULL, NULL, 0, "<Branch>"},
  {"/Tags/Common/Anchor/t1", NULL, NULL, 0, "<Tearoff>"},
  {"/Tags/Common/Anchor/Internal", NULL, tag_insert_exec, 56, ""},
  {"/Tags/Common/Anchor/External", NULL, tag_insert_exec, 57, ""},

  {"/Tags/Common/sep10", NULL, NULL, 0, "<Separator>"},
  {"/Tags/Common/Blockquote", NULL, tag_insert_exec, 9, ""},
  {"/Tags/Common/Line Break", NULL, tag_insert_exec, 10, ""},
  {"/Tags/Common/Comment", NULL, html_comment, 12, ""},
  {"/Tags/Common/Horizontal ruler", NULL, tag_insert_exec, 34, ""},
  {"/Tags/Common/Image", NULL, tag_insert_exec, 55, ""},
  {"/Tags/Common/Insert path", NULL, dialog_insert_path, 0, ""},

  {"/Tags/Font", NULL, NULL, 0, "<Branch>"},
  {"/Tags/Font/t1", NULL, NULL, 0, "<Tearoff>"},
  {"/Tags/Font/Big text", NULL, tag_insert_exec, 13, ""},
  {"/Tags/Font/Small text", NULL, tag_insert_exec, 14, ""},
  {"/Tags/Font/Blinking text", NULL, tag_insert_exec, 15, ""},
  {"/Tags/Font/sep11", NULL, NULL, 0, "<Separator>"},
  {"/Tags/Font/Emphasis", NULL, tag_insert_exec, 22, ""},
  {"/Tags/Font/Striked", NULL, tag_insert_exec, 23, ""},
  {"/Tags/Font/Superscript", NULL, tag_insert_exec, 24, ""},
  {"/Tags/Font/Subscript", NULL, tag_insert_exec, 25, ""},
  {"/Tags/Font/Teletype text", NULL, tag_insert_exec, 26, ""},
  {"/Tags/Font/Keyboard text", NULL, tag_insert_exec, 27, ""},
  {"/Tags/Font/sep12", NULL, NULL, 0, "<Separator>"},
  {"/Tags/Font/Listing", NULL, tag_insert_exec, 28, ""},
  {"/Tags/Font/Code", NULL, tag_insert_exec, 29, ""},
  {"/Tags/Font/Cite", NULL, tag_insert_exec, 16, ""},


  {"/Tags/Page", NULL, NULL, 0, "<Branch>"},
  {"/Tags/Page/t1", NULL, NULL, 0, "<Tearoff>"},
  {"/Tags/Page/HTML", "<control>H", tag_insert_exec, 17, ""},
  {"/Tags/Page/Head", NULL, tag_insert_exec, 18, ""},
  {"/Tags/Page/Body", NULL, tag_insert_exec, 19, ""},
  {"/Tags/Page/Title", NULL, tag_insert_exec, 20, ""},
  {"/Tags/Page/sep13", NULL, NULL, 0, "<Separator>"},
  {"/Tags/Page/Meta informations", NULL, load_meta_info, 0, ""},
  {"/Tags/Page/Banner", NULL, tag_insert_exec, 21, ""},
  {"/Tags/Page/Document type", NULL, init_doctypelist, 0, ""},
  {"/Tags/Page/sep14", NULL, NULL, 0, "<Separator>"},
  {"/Tags/Page/Internal anchor", NULL, tag_insert_exec, 56, ""},
  {"/Tags/Page/Internal link", NULL, tag_insert_exec, 57, ""},
  {"/Tags/Page/Link to top", NULL, tag_insert_exec, 58, ""},

  {"/Tags/Form", NULL, NULL, 0, "<Branch>"},
  {"/Tags/Form/t1", NULL, NULL, 0, "<Tearoff>"},
  {"/Tags/Form/Form", NULL, tag_insert_exec, 45, ""},
  {"/Tags/Form/Input", NULL, NULL, 0, "<Branch>"},
  {"/Tags/Form/Input/t1", NULL, NULL, 0, "<Tearoff>"},
  {"/Tags/Form/Input/Hidden", NULL, tag_insert_exec, 46, ""},
  {"/Tags/Form/Input/Password", NULL, tag_insert_exec, 30, ""},
  {"/Tags/Form/Input/Text", NULL, tag_insert_exec, 31, ""},
  {"/Tags/Form/Input/Reset", NULL, tag_insert_exec, 32, ""},
  {"/Tags/Form/Input/Submit", NULL, tag_insert_exec, 33, ""},
  {"/Tags/Form/Input/Hidden", NULL, tag_insert_exec, 46, ""},
  {"/Tags/Form/Button", NULL, tag_insert_exec, 48, ""},
  {"/Tags/Form/sep15", NULL, NULL, 0, "<Separator>"},
  {"/Tags/Form/Checkbox", NULL, tag_insert_exec, 35, ""},
  {"/Tags/Form/Radio", NULL, tag_insert_exec, 36, ""},
  {"/Tags/Form/Text area", NULL, tag_insert_exec, 44, ""},
  {"/Tags/Form/Fieldset", NULL, tag_insert_exec, 44, ""},

  {"/Tags/Table", NULL, NULL, 0, "<Branch>"},
  {"/Tags/Table/t1", NULL, NULL, 0, "<Tearoff>"},
  {"/Tags/Table/Table", NULL, tag_insert_exec, 61, ""},
  {"/Tags/Table/Head", NULL, tag_insert_exec, 62, ""},
  {"/Tags/Table/Row", NULL, tag_insert_exec, 63, ""},
  {"/Tags/Table/Data", NULL, tag_insert_exec, 64, ""},
  {"/Tags/Table/Caption", NULL, tag_insert_exec, 65, ""},

  {"/Tags/List", NULL, NULL, 0, "<Branch>"},
  {"/Tags/List/t1", NULL, NULL, 0, "<Tearoff>"},
  {"/Tags/List/Ordered list", NULL, tag_insert_exec, 38, ""},
  {"/Tags/List/Unordered list", NULL, tag_insert_exec, 39, ""},
  {"/Tags/List/List item", NULL, tag_insert_exec, 40, ""},
  {"/Tags/List/sep16", NULL, NULL, 0, "<Separator>"},
  {"/Tags/List/Data definition", NULL, tag_insert_exec, 41, ""},
  {"/Tags/List/Data term", NULL, tag_insert_exec, 42, ""},
  {"/Tags/List/Descriptive list", NULL, tag_insert_exec, 43, ""},
  {"/Tags/List/sep17", NULL, NULL, 0, "<Separator>"},
  {"/Tags/List/Directory list", NULL, tag_insert_exec, 59, ""},
  {"/Tags/List/Menu", NULL, tag_insert_exec, 60, ""},


  {"/_Options", NULL, NULL, 0, "<Branch>"},
  {"/Options/t1", NULL, NULL, 0, "<Tearoff>"},
  {"/Options/Text Editable", NULL, text_toggle_editable, 0, "<ToggleItem>"},
  {"/Options/Text Wordwrapped", NULL, text_toggle_word_wrap, 0, "<ToggleItem>"},
  {"/Options/Toggle help bar", NULL, tab_window_toggle, 0, "<ToggleItem>"},
  {"/Options/Browser path...", NULL, browser_path, 0, ""},
  {"/Options/Tab position", NULL, NULL, 0, "<Branch>"},
  {"/Options/Tab position/t1", NULL, NULL, 0, "<Tearoff>"},
  {"/Options/Tab position/up", NULL, toggle_tab_pos, 2, ""},
  {"/Options/Tab position/down", NULL, toggle_tab_pos, 3, ""},
  {"/Options/Tab position/left", NULL, toggle_tab_pos, 0, ""},
  {"/Options/Tab position/right", NULL, toggle_tab_pos, 1, ""},


  {"/_Windows", NULL, NULL, 0, "<Branch>"},
  {"/Windows/t1", NULL, NULL, 0, "<Tearoff>"},
  {"/Windows/New window", NULL, new_window, 0, NULL},
  {"/Windows/Start a terminal", "<control>T", terminal, 0, NULL},
  {"/_Windows/Preview", NULL, NULL, 0, "<Branch>"},
  {"/Windows/Preview/t1", NULL, NULL, 0, "<Tearoff>"},
  {"/Windows/Preview/Internal previewer", NULL, int_view, 0, ""},
  {"/Windows/Preview/Preview with external browser", NULL, netscape_view, 0, ""},


  {"/_Help", NULL, NULL, 0, "<LastBranch>"},
  {"/Help/t1", NULL, NULL, 0, "<Tearoff>"},
  {"/Help/Help...", "F1", helpwindow, 0, NULL},
  {"/Help/About...", "F2", about, 0, NULL},
};

void
get_main_menu (GtkWidget * window, GtkWidget ** menubar)
{

  int nmenu_items = sizeof (menu_items) / sizeof (menu_items[0]);
  GtkItemFactory *myitem_factory;
  GtkAccelGroup *myaccel_group;
  myaccel_group = gtk_accel_group_new ();
  myitem_factory = gtk_item_factory_new (GTK_TYPE_MENU_BAR, "<main>", myaccel_group);
  gtk_item_factory_create_items (myitem_factory, nmenu_items, menu_items, NULL);
  gtk_accel_group_attach (myaccel_group, GTK_OBJECT (window));
  if (menubar)
    *menubar = gtk_item_factory_get_widget (myitem_factory, "<main>");
}				/* fin de getmain_menu() */



int
main (int argc, char *argv[])
{
  GtkWidget *vscrollbar;
  GtkWidget *hbox;


/* primary initialization */
  numfileopened = 0;
  numprjfiles = 0;
  clist_row2 = 1;
  lasttag_nb = -1;
  prjsaved = TRUE;
  prjopnd = FALSE;
  prjnew = FALSE;
  instring = FALSE;
  intag = FALSE;
  tab_activ = TRUE;

/* loads the configuration (not used yet) */
/*  load_config(); */

/* ToolKits and Library initialization */
/*
  bindtextdomain
  textdomain ("wdesign");
*/
  gtk_init (&argc, &argv);

  sprintf (projectname, "%s", _("none"));

/*  Load a fixed font */
fixed_font = gdk_font_load ("-misc-fixed-medium-r-normal-*-*-120-*-*-c-*-iso8859-1");

/* Get the system colour map and allocate the colour red */
  cmap = gdk_colormap_get_system ();

  red.red = 0xafff;
  red.green = 0;
  red.blue = 0;
  if (!gdk_color_alloc (cmap, &red))
    {
      g_error (_("couldn't allocate colour"));
    }

  green.red = 0;
  green.green = 0xafff;
  green.blue = 0;
  if (!gdk_color_alloc (cmap, &green))
    {
      g_error (_("couldn't allocate colour"));
    }

  black.red = 0;
  black.green = 0;
  black.blue = 0;
  if (!gdk_color_alloc (cmap, &black))
    {
      g_error (_("couldn't allocate colour"));
    }

  blue.red = 0x6700;
  blue.green = 0x5900;
  blue.blue = 0xff00;
  if (!gdk_color_alloc (cmap, &blue))
    {
      g_error (_("couldn't allocate colour"));
    }

/*  Main window of the software */

    window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_signal_connect (GTK_OBJECT (window), "destroy", GTK_SIGNAL_FUNC (gtk_main_quit), "WM destroy");
  gtk_window_set_title (GTK_WINDOW (window), "Web Designer");

  main_vbox = gtk_vbox_new (FALSE, 1);
  gtk_container_border_width (GTK_CONTAINER (main_vbox), 0);
  gtk_container_add (GTK_CONTAINER (window), main_vbox);
  gtk_widget_show (main_vbox);

  gtk_widget_set_usize (GTK_WIDGET (main_vbox), 640, 460);

  get_main_menu (window, &menubar);
  gtk_box_pack_start (GTK_BOX (main_vbox), menubar, FALSE, TRUE, 0);
  gtk_widget_show (menubar);

  gtk_window_set_policy (GTK_WINDOW (window), FALSE, TRUE, TRUE);
  gtk_widget_realize (window);

  /* Create a new notebook */
  notebook0 = gtk_notebook_new ();

  /* initialise le menu popup */
  init_popmenu ();

  load_first_toolbar ();

  gtk_notebook_set_tab_pos (GTK_NOTEBOOK (notebook0), GTK_POS_TOP);
  gtk_notebook_set_scrollable (GTK_NOTEBOOK (notebook0), 1);
  gtk_box_pack_start (GTK_BOX (main_vbox), notebook0, FALSE, FALSE, 0);
  gtk_widget_show (notebook0);

  /* Create a new notebook */
  notebook = gtk_notebook_new ();
  gtk_notebook_set_tab_pos (GTK_NOTEBOOK (notebook), GTK_POS_TOP);
  gtk_notebook_set_scrollable (GTK_NOTEBOOK (notebook), 1);
  gtk_box_pack_start (GTK_BOX (main_vbox), notebook, TRUE, TRUE, 0);
  gtk_widget_show (notebook);

  /* create the box for the tooltip window */
  hbox2 = gtk_hbox_new (FALSE, 1);

  /* Create the tag info window */
  tag_window = gtk_text_new (NULL, NULL);
  gtk_text_freeze (GTK_TEXT (tag_window));

  vscrollbar = gtk_vscrollbar_new (GTK_TEXT (tag_window)->vadj);

  /* Startup tool tips should be inserted here !!! */
  gtk_text_thaw (GTK_TEXT (tag_window));
  gtk_box_pack_start (GTK_BOX (hbox2), tag_window, TRUE, TRUE, 2);
  gtk_box_pack_start (GTK_BOX (hbox2), vscrollbar, FALSE, FALSE, 2);
  widget_style (GTK_WIDGET (tag_window));

  gtk_widget_set_usize (GTK_WIDGET (hbox2), 50, 85);
  gtk_box_pack_start (GTK_BOX (main_vbox), hbox2, FALSE, TRUE, 2);
  gtk_widget_show_all (hbox2);

  hbox = gtk_hbox_new (FALSE, 1);

  /* Create a new status bar */
  status_bar = gtk_statusbar_new ();
  gtk_box_pack_start (GTK_BOX (hbox), status_bar, TRUE, TRUE, 10);
  gtk_widget_show (status_bar);
  context_id = gtk_statusbar_get_context_id (GTK_STATUSBAR (status_bar), "Status_bar");

  /* Create a new status bar */
  file_status_bar = gtk_statusbar_new ();
  gtk_box_pack_end (GTK_BOX (hbox), file_status_bar, FALSE, TRUE, 10);
  gtk_widget_show (file_status_bar);
  context_id = gtk_statusbar_get_context_id (GTK_STATUSBAR (file_status_bar), "file_status_bar");

  /* Create a new status bar */
  coord_status_bar = gtk_statusbar_new ();
  gtk_box_pack_end (GTK_BOX (hbox), coord_status_bar, FALSE, FALSE, 2);
  gtk_widget_show (coord_status_bar);
  context_id = gtk_statusbar_get_context_id (GTK_STATUSBAR (coord_status_bar), "coord_status_bar");

  gtk_box_pack_start (GTK_BOX (main_vbox), hbox, FALSE, TRUE, 2);
  gtk_widget_show (hbox);

  gtk_statusbar_push (GTK_STATUSBAR (coord_status_bar), context_id, _(" Ligne : 0, Colonne : 0 "));


  gtk_signal_connect_after (GTK_OBJECT (notebook), "switch_page", GTK_SIGNAL_FUNC (gtk_swpg), NULL);

	  newfile ();

  if (argc != 1)
    {
      if (!strcmp (argv[1], "--version"))
	{
	  printf (_("\n  Web Designer %d.%d.%d\n\n"), major_version, minor_version, revision_version);
	  exit (-1);
	}

      if (!strcmp (argv[1], "--help"))
	{
/*

   printf ("\n  Web Designer %d.%d.%d\n\n", major, minor, revision);
   printf ("  Syntaxe : wdesign [options] [fichier]...\n\n");
   printf ("  Options :\n");
   printf ("    --help     affiche cet cran\n");
   printf ("    --version  affiche la version courante de Web Designer\n");
   printf ("    --file     lance le(s) fichier(s) 'fichier' au dmarrage de Web Designer\n");
   printf ("    --project  lance le projet 'fichier' au dmarrage de Web Designer\n");  
 */
	  printf (_("\n  Web Designer %d.%d.%d\n\n"), major_version, minor_version, revision_version);
	  printf (_("  Synopsys : wdesign [options] [file]...\n\n"));
	  printf (_("  Options :\n"));
	  printf (_("  	--help     shows this screen\n"));
	  printf (_("  	--version  shows the current version of Web Designer\n"));
	  printf (_("  	--file     Open the file 'file' on Web Designer's startup\n"));
	  printf (_("  	--project  Open the project 'project' on Web Designer's startup\n"));

	  exit (-1);
	}

      if (argc == 2)
	{
/*
   printf ("\n  Erreur : nombre d'argument insuffisant\n");
   printf ("  Tapez 'wdesign --help' pour plus d'informations\n\n");
 */
	  printf (_("\n  Error : not enough argument\n"));
	  printf (_("  Type 'wdesign --help' for more informations\n\n"));

	  exit (-1);
	}

      if (!strcmp (argv[1], "--file"))
	{
	  int i;
	  close_file ();
	  for (i = 2; i < argc; i++)
	    {
	      openfile2 (argv[i], FALSE, FALSE);
	    }
	}

      if (!strcmp (argv[1], "--project"))
	{
	  close_file ();
	  if (open_project2 (argv[2]) == -1)
	    newfile ();
	}
    }

  gtk_widget_show (window);
  gtk_widget_grab_focus (sheet[curfile].text);
  gtk_main ();


  return (0);
}
