/* Web Designer
   Copyright (C) 1999  LADISLAS Willhem

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

   Author's email : zillprog@freesurf.fr
   
   snailmail :
   LADISLAS Willhem
   2, rue du Serpolet
   95490 VAUREAL
   FRANCE
 */

#include <gtk/gtk.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <ctype.h>
#include "../config.h"
#include "wintl.h"

#define major_version 0
#define minor_version 0
#define revision_version 20

/* #define debugging 1 */

	/* Widgets utiliss */
GtkWidget *menubar;
GtkWidget *window;
GtkWidget *dialog_window;
GtkWidget *filew;
GtkWidget *status_bar;
GtkWidget *file_status_bar;
GtkWidget *coord_status_bar;
GtkWidget *notebook;
GtkWidget *notebook0;
GtkWidget *main_vbox;
GtkWidget *clist;
GtkWidget *clistdialog;
GtkWidget *clistvbox;
GtkWidget *popmenu;
GtkWidget *popmenu2;
GtkWidget *clist_lbl;
GtkWidget *mainmenubar;
GtkWidget *tag_window;
GtkWidget *hbox2;
gboolean tab_activ;

GdkColormap *cmap;
GdkColor color;
GdkColor red;
GdkColor black;
GdkColor blue;
GdkColor green;
GdkColor colour;
GdkColor savecol;

GdkFont *fixed_font;
GdkPixmap *pixm;

short editok, wrapok;
short curfile, numfileopened;
gint context_id;
gint clist_row2;
char projectname[255];
int lasttag_nb;
gint numprjfiles;
char browser_command[255];
gboolean acc;
gboolean prjsaved;
gboolean prjopnd;
gboolean prjnew;
gboolean instring;
gboolean intag;
gboolean diese;

struct widsheet
  {
    GtkWidget *table;
    GtkWidget *vscrollbar;
    GtkWidget *text;
    char fichier[255];
    char chemin[255];
    char type[20];
    gboolean acces;		/* 0= read only, 1=read/write since write is unuseful */
    gboolean new;
    gboolean inprj;
    gboolean saved;
  };

struct proje
  {
    char path[255];
  };

/* allocate file variables : 150 files max, (it can be increased but... our memory is limited) */
struct widsheet sheet[150];
struct proje projectfiles[150];

void remove_tags(void);
void tab_window_toggle (void);
void toggle_tab_pos(GtkWidget * w, int Opcode);
void browser_path(void);
void insert_path_exec(GtkWidget * w, GtkFileSelection * fs);
void dialog_insert_path(void);
void widget_style (GtkWidget * wgt);
char *getpath (char *path);
void clipboard_actions (GtkWidget * w, guint Op);
void init_doctypelist (void);
void load_meta_info (void);
void repeat_tag (void);
void inst_txt (GtkEditable * editable, const char *text, int len, int *pos, gpointer data);
void close_primary2 (void);
void compact_file (GtkWidget *w, int Opcode);
void add_afile_prj_dialog (void);
void edit_file_exec (void);
void open_all_prjfiles (void);
void close_all_prjfiles (void);
void tag_insert_exec (GtkWidget * widget, int Opcode);
void close_primary (void);
void choose_H (void);
void html_comment (void);

void refresh_clist (void);
void display_file_info (void);
void import_file_exec (GtkWidget * w, GtkFileSelection * fs);
void import_file_dialog (void);
void coord (GtkWidget * widget, gpointer data);
void print_file (void);
void save_project (GtkWidget * w, int opcode);
void save_project_under_dialog (void);
void new_project (void);
void ask_for (gchar * label);
void load_first_toolbar (void);
void clist_selection_made (GtkWidget * clist, gint row, gint column, GdkEventButton * event, gpointer data);
void insert_date (void);
void insert_date_exec (GtkWidget * widget, gpointer data);
void terminal (void);
void new_window (void);
void merror (gchar * label);
void open_project (GtkWidget * w, GtkFileSelection * fs);
int open_project2 (gchar * prjnm);
void open_project_dialog (void);
void close_project (void);
void save_project_under (void);
int openfile2 (gchar * filepath, gboolean nouveau, gboolean prj);
void netscape_view (void);
void int_view (void);
void file_modified (void);
gint button_press (GtkWidget * widget, GdkEvent * event);
gint button_press_coord (GtkWidget * widget, GdkEvent * event);
void init_popmenu (void);
void savefile (void);
void go_line (void);
void select_all (void);
void erase_selection (void);
void paste_in_new_file (void);
void copy_clipboard (void);
void cut_clipboard (void);
void paste_clipboard (void);
void close_file (void);
void remove_file (void);
void remove_file2 (void);
void add_file (void);
void close_all_files (void);
void gtk_swpg (void);
void init_clist (void);
void filesaveas (GtkWidget * w, GtkFileSelection * fs);
void dialogsaveas (void);
void insert_lbl (GtkWidget * wid, gchar * labe);
void insert_space (GtkWidget * wid);

void updatefilelist (short num);

GtkWidget *new_pixmap (int type, GdkWindow * window, GdkColor * background);
void text_toggle_editable (void);
void text_toggle_word_wrap (void);
void close_application (GtkWidget * widget, gpointer data);
char *getname (char *path);
char *getext (char *path);
void nfile (GtkWidget * w, GtkFileSelection * fs);
void newfile (void);
void openfile (void);
void helpwindow (void);
void about (void);
void config (void);
void get_main_menu (GtkWidget * window, GtkWidget ** menubar);
